/* A Bison parser, made by GNU Bison 3.7.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2020 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30704

/* Bison version string.  */
#define YYBISON_VERSION "3.7.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         ir3_yyparse
#define yylex           ir3_yylex
#define yyerror         ir3_yyerror
#define yydebug         ir3_yydebug
#define yynerrs         ir3_yynerrs
#define yylval          ir3_yylval
#define yychar          ir3_yychar

/* First part of user prologue.  */
#line 32 "../src/freedreno/ir3/ir3_parser.y"

#define YYDEBUG 0

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>

#include "util/half_float.h"
#include "util/u_math.h"

#include "ir3/ir3.h"
#include "ir3/ir3_shader.h"
#include "ir3/instr-a3xx.h"

#include "ir3_parser.h"

#define swap(a, b) \
	do { __typeof(a) __tmp = (a); (a) = (b); (b) = __tmp; } while (0)

/* ir3 treats the abs/neg flags as separate flags for float vs integer,
 * but in the instruction encoding they are the same thing.  Tracking
 * them separately is only for the benefit of ir3 opt passes, and not
 * required here, so just use the float versions:
 */
#define IR3_REG_ABS     IR3_REG_FABS
#define IR3_REG_NEGATE  IR3_REG_FNEG

static struct ir3_kernel_info    *info;
static struct ir3_shader_variant *variant;
/* NOTE the assembler doesn't really use the ir3_block construction
 * like the compiler does.  Everything is treated as one large block.
 * Which might happen to contain flow control.  But since we don't
 * use any of the ir3 backend passes (sched, RA, etc) this doesn't
 * really matter.
 */
static struct ir3_block          *block;   /* current shader block */
static struct ir3_instruction    *instr;   /* current instruction */
static unsigned ip; /* current instruction pointer */
static struct hash_table *labels;

void *ir3_parser_dead_ctx;

static struct {
	unsigned flags;
	unsigned repeat;
	unsigned nop;
} iflags;

static struct {
	unsigned flags;
	unsigned wrmask;
} rflags;

int ir3_yyget_lineno(void);

static void new_label(const char *name)
{
	ralloc_steal(labels, (void *) name);
	_mesa_hash_table_insert(labels, name, (void *)(uintptr_t)ip);
}

static struct ir3_instruction * new_instr(opc_t opc)
{
	instr = ir3_instr_create(block, opc, 4, 6);
	instr->flags = iflags.flags;
	instr->repeat = iflags.repeat;
	instr->nop = iflags.nop;
	instr->line = ir3_yyget_lineno();
	iflags.flags = iflags.repeat = iflags.nop = 0;
	ip++;
	return instr;
}

static void new_shader(void)
{
	variant->ir = ir3_create(variant->shader->compiler, variant);
	block = ir3_block_create(variant->ir);
	list_addtail(&block->node, &variant->ir->block_list);
	ip = 0;
	labels = _mesa_hash_table_create(variant, _mesa_hash_string, _mesa_key_string_equal);
	ir3_parser_dead_ctx = ralloc_context(NULL);
}

static type_t parse_type(const char **type)
{
	if (!strncmp("f16", *type, 3)) {
		*type += 3;
		return TYPE_F16;
	} else if (!strncmp("f32", *type, 3)) {
		*type += 3;
		return TYPE_F32;
	} else if (!strncmp("u16", *type, 3)) {
		*type += 3;
		return TYPE_U16;
	} else if (!strncmp("u32", *type, 3)) {
		*type += 3;
		return TYPE_U32;
	} else if (!strncmp("s16", *type, 3)) {
		*type += 3;
		return TYPE_S16;
	} else if (!strncmp("s32", *type, 3)) {
		*type += 3;
		return TYPE_S32;
	} else if (!strncmp("u8", *type, 2)) {
		*type += 2;
		return TYPE_U8;
	} else if (!strncmp("s8", *type, 2)) {
		*type += 2;
		return TYPE_S8;
	} else {
		assert(0);  /* shouldn't get here */
		return ~0;
	}
}

static struct ir3_instruction * parse_type_type(struct ir3_instruction *instr,
		const char *type_type)
{
	instr->cat1.src_type = parse_type(&type_type);
	instr->cat1.dst_type = parse_type(&type_type);
	return instr;
}

static struct ir3_register * new_src(int num, unsigned flags)
{
	struct ir3_register *reg;
	flags |= rflags.flags;
	if (num & 0x1)
		flags |= IR3_REG_HALF;
	reg = ir3_src_create(instr, num>>1, flags);
	reg->wrmask = MAX2(1, rflags.wrmask);
	rflags.flags = rflags.wrmask = 0;
	return reg;
}

static struct ir3_register * new_dst(int num, unsigned flags)
{
	struct ir3_register *reg;
	flags |= rflags.flags;
	if (num & 0x1)
		flags |= IR3_REG_HALF;
	reg = ir3_dst_create(instr, num>>1, flags);
	reg->wrmask = MAX2(1, rflags.wrmask);
	rflags.flags = rflags.wrmask = 0;
	return reg;
}

static struct ir3_register * dummy_dst(void)
{
	return new_dst(0, 0);
}

static void fixup_cat5_s2en(void)
{
	assert(opc_cat(instr->opc) == 5);
	if (!(instr->flags & IR3_INSTR_S2EN))
		return;
	/* For various reasons (ie. mainly to make the .s2en src easier to
	 * find, given that various different cat5 tex instructions can have
	 * different # of src registers), in ir3 the samp/tex src register
	 * is first, rather than last.  So we have to detect this case and
	 * fix things up.
	 */
	struct ir3_register *s2en_src = instr->srcs[instr->srcs_count - 1];

	if (instr->flags & IR3_INSTR_B)
		assert(!(s2en_src->flags & IR3_REG_HALF));
	else
		assert(s2en_src->flags & IR3_REG_HALF);

	for (int i = 0; i < instr->srcs_count - 1; i++) {
		instr->srcs[i+1] = instr->srcs[i];
	}
	instr->srcs[0] = s2en_src;
}

static void add_const(unsigned reg, unsigned c0, unsigned c1, unsigned c2, unsigned c3)
{
	struct ir3_const_state *const_state = ir3_const_state(variant);
	assert((reg & 0x7) == 0);
	int idx = reg >> (1 + 2); /* low bit is half vs full, next two bits are swiz */
	if (idx * 4 + 4 > const_state->immediates_size) {
		const_state->immediates = rerzalloc(const_state,
				const_state->immediates,
				__typeof__(const_state->immediates[0]),
				const_state->immediates_size,
				idx * 4 + 4);
		for (unsigned i = const_state->immediates_size; i < idx * 4; i++)
			const_state->immediates[i] = 0xd0d0d0d0;
		const_state->immediates_size = const_state->immediates_count = idx * 4 + 4;
	}
	const_state->immediates[idx * 4 + 0] = c0;
	const_state->immediates[idx * 4 + 1] = c1;
	const_state->immediates[idx * 4 + 2] = c2;
	const_state->immediates[idx * 4 + 3] = c3;
}

static void add_sysval(unsigned reg, unsigned compmask, gl_system_value sysval)
{
	unsigned n = variant->inputs_count++;
	variant->inputs[n].regid = reg;
	variant->inputs[n].sysval = true;
	variant->inputs[n].slot = sysval;
	variant->inputs[n].compmask = compmask;
	variant->total_in++;
}

static bool resolve_labels(void)
{
	int instr_ip = 0;
	foreach_instr (instr, &block->instr_list) {
		if (opc_cat(instr->opc) == 0 && instr->cat0.target_label) {
			struct hash_entry *entry = _mesa_hash_table_search(labels, instr->cat0.target_label);
			if (!entry) {
				fprintf(stderr, "unknown label %s\n", instr->cat0.target_label);
				return false;
			}
			int target_ip = (uintptr_t)entry->data;
			instr->cat0.immed = target_ip - instr_ip;
		}
		instr_ip++;
	}
	return true;
}

#ifdef YYDEBUG
int yydebug;
#endif

extern int yylex(void);
void ir3_yyset_lineno(int _line_number);
void ir3_yyset_input(FILE *f);

int yyparse(void);

static void yyerror(const char *error)
{
	fprintf(stderr, "error at line %d: %s\n", ir3_yyget_lineno(), error);
}

struct ir3 * ir3_parse(struct ir3_shader_variant *v,
		struct ir3_kernel_info *k, FILE *f)
{
	ir3_yyset_lineno(1);
	ir3_yyset_input(f);
#ifdef YYDEBUG
	yydebug = 1;
#endif
	info = k;
	variant = v;
	if (yyparse() || !resolve_labels()) {
		ir3_destroy(variant->ir);
		variant->ir = NULL;
	}
	ralloc_free(labels);
	ralloc_free(ir3_parser_dead_ctx);
	return variant->ir;
}

#line 339 "src/freedreno/ir3/ir3_parser.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "ir3_parser.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_T_INT = 3,                      /* T_INT  */
  YYSYMBOL_T_HEX = 4,                      /* T_HEX  */
  YYSYMBOL_T_FLOAT = 5,                    /* T_FLOAT  */
  YYSYMBOL_T_IDENTIFIER = 6,               /* T_IDENTIFIER  */
  YYSYMBOL_T_REGISTER = 7,                 /* T_REGISTER  */
  YYSYMBOL_T_CONSTANT = 8,                 /* T_CONSTANT  */
  YYSYMBOL_T_A_LOCALSIZE = 9,              /* T_A_LOCALSIZE  */
  YYSYMBOL_T_A_CONST = 10,                 /* T_A_CONST  */
  YYSYMBOL_T_A_BUF = 11,                   /* T_A_BUF  */
  YYSYMBOL_T_A_INVOCATIONID = 12,          /* T_A_INVOCATIONID  */
  YYSYMBOL_T_A_WGID = 13,                  /* T_A_WGID  */
  YYSYMBOL_T_A_NUMWG = 14,                 /* T_A_NUMWG  */
  YYSYMBOL_T_A_BRANCHSTACK = 15,           /* T_A_BRANCHSTACK  */
  YYSYMBOL_T_A_IN = 16,                    /* T_A_IN  */
  YYSYMBOL_T_A_OUT = 17,                   /* T_A_OUT  */
  YYSYMBOL_T_A_TEX = 18,                   /* T_A_TEX  */
  YYSYMBOL_T_A_PVTMEM = 19,                /* T_A_PVTMEM  */
  YYSYMBOL_T_ABSNEG = 20,                  /* T_ABSNEG  */
  YYSYMBOL_T_NEG = 21,                     /* T_NEG  */
  YYSYMBOL_T_ABS = 22,                     /* T_ABS  */
  YYSYMBOL_T_R = 23,                       /* T_R  */
  YYSYMBOL_T_HR = 24,                      /* T_HR  */
  YYSYMBOL_T_HC = 25,                      /* T_HC  */
  YYSYMBOL_T_EVEN = 26,                    /* T_EVEN  */
  YYSYMBOL_T_POS_INFINITY = 27,            /* T_POS_INFINITY  */
  YYSYMBOL_T_NEG_INFINITY = 28,            /* T_NEG_INFINITY  */
  YYSYMBOL_T_EI = 29,                      /* T_EI  */
  YYSYMBOL_T_WRMASK = 30,                  /* T_WRMASK  */
  YYSYMBOL_T_FLUT_0_0 = 31,                /* T_FLUT_0_0  */
  YYSYMBOL_T_FLUT_0_5 = 32,                /* T_FLUT_0_5  */
  YYSYMBOL_T_FLUT_1_0 = 33,                /* T_FLUT_1_0  */
  YYSYMBOL_T_FLUT_2_0 = 34,                /* T_FLUT_2_0  */
  YYSYMBOL_T_FLUT_E = 35,                  /* T_FLUT_E  */
  YYSYMBOL_T_FLUT_PI = 36,                 /* T_FLUT_PI  */
  YYSYMBOL_T_FLUT_INV_PI = 37,             /* T_FLUT_INV_PI  */
  YYSYMBOL_T_FLUT_INV_LOG2_E = 38,         /* T_FLUT_INV_LOG2_E  */
  YYSYMBOL_T_FLUT_LOG2_E = 39,             /* T_FLUT_LOG2_E  */
  YYSYMBOL_T_FLUT_INV_LOG2_10 = 40,        /* T_FLUT_INV_LOG2_10  */
  YYSYMBOL_T_FLUT_LOG2_10 = 41,            /* T_FLUT_LOG2_10  */
  YYSYMBOL_T_FLUT_4_0 = 42,                /* T_FLUT_4_0  */
  YYSYMBOL_T_SY = 43,                      /* T_SY  */
  YYSYMBOL_T_SS = 44,                      /* T_SS  */
  YYSYMBOL_T_JP = 45,                      /* T_JP  */
  YYSYMBOL_T_SAT = 46,                     /* T_SAT  */
  YYSYMBOL_T_RPT = 47,                     /* T_RPT  */
  YYSYMBOL_T_UL = 48,                      /* T_UL  */
  YYSYMBOL_T_NOP = 49,                     /* T_NOP  */
  YYSYMBOL_T_OP_NOP = 50,                  /* T_OP_NOP  */
  YYSYMBOL_T_OP_BR = 51,                   /* T_OP_BR  */
  YYSYMBOL_T_OP_BRAO = 52,                 /* T_OP_BRAO  */
  YYSYMBOL_T_OP_BRAA = 53,                 /* T_OP_BRAA  */
  YYSYMBOL_T_OP_BRAC = 54,                 /* T_OP_BRAC  */
  YYSYMBOL_T_OP_BANY = 55,                 /* T_OP_BANY  */
  YYSYMBOL_T_OP_BALL = 56,                 /* T_OP_BALL  */
  YYSYMBOL_T_OP_BRAX = 57,                 /* T_OP_BRAX  */
  YYSYMBOL_T_OP_JUMP = 58,                 /* T_OP_JUMP  */
  YYSYMBOL_T_OP_CALL = 59,                 /* T_OP_CALL  */
  YYSYMBOL_T_OP_RET = 60,                  /* T_OP_RET  */
  YYSYMBOL_T_OP_KILL = 61,                 /* T_OP_KILL  */
  YYSYMBOL_T_OP_END = 62,                  /* T_OP_END  */
  YYSYMBOL_T_OP_EMIT = 63,                 /* T_OP_EMIT  */
  YYSYMBOL_T_OP_CUT = 64,                  /* T_OP_CUT  */
  YYSYMBOL_T_OP_CHMASK = 65,               /* T_OP_CHMASK  */
  YYSYMBOL_T_OP_CHSH = 66,                 /* T_OP_CHSH  */
  YYSYMBOL_T_OP_FLOW_REV = 67,             /* T_OP_FLOW_REV  */
  YYSYMBOL_T_OP_BKT = 68,                  /* T_OP_BKT  */
  YYSYMBOL_T_OP_STKS = 69,                 /* T_OP_STKS  */
  YYSYMBOL_T_OP_STKR = 70,                 /* T_OP_STKR  */
  YYSYMBOL_T_OP_XSET = 71,                 /* T_OP_XSET  */
  YYSYMBOL_T_OP_XCLR = 72,                 /* T_OP_XCLR  */
  YYSYMBOL_T_OP_GETONE = 73,               /* T_OP_GETONE  */
  YYSYMBOL_T_OP_DBG = 74,                  /* T_OP_DBG  */
  YYSYMBOL_T_OP_SHPS = 75,                 /* T_OP_SHPS  */
  YYSYMBOL_T_OP_SHPE = 76,                 /* T_OP_SHPE  */
  YYSYMBOL_T_OP_PREDT = 77,                /* T_OP_PREDT  */
  YYSYMBOL_T_OP_PREDF = 78,                /* T_OP_PREDF  */
  YYSYMBOL_T_OP_PREDE = 79,                /* T_OP_PREDE  */
  YYSYMBOL_T_OP_MOVMSK = 80,               /* T_OP_MOVMSK  */
  YYSYMBOL_T_OP_MOVA1 = 81,                /* T_OP_MOVA1  */
  YYSYMBOL_T_OP_MOVA = 82,                 /* T_OP_MOVA  */
  YYSYMBOL_T_OP_MOV = 83,                  /* T_OP_MOV  */
  YYSYMBOL_T_OP_COV = 84,                  /* T_OP_COV  */
  YYSYMBOL_T_OP_SWZ = 85,                  /* T_OP_SWZ  */
  YYSYMBOL_T_OP_GAT = 86,                  /* T_OP_GAT  */
  YYSYMBOL_T_OP_SCT = 87,                  /* T_OP_SCT  */
  YYSYMBOL_T_OP_ADD_F = 88,                /* T_OP_ADD_F  */
  YYSYMBOL_T_OP_MIN_F = 89,                /* T_OP_MIN_F  */
  YYSYMBOL_T_OP_MAX_F = 90,                /* T_OP_MAX_F  */
  YYSYMBOL_T_OP_MUL_F = 91,                /* T_OP_MUL_F  */
  YYSYMBOL_T_OP_SIGN_F = 92,               /* T_OP_SIGN_F  */
  YYSYMBOL_T_OP_CMPS_F = 93,               /* T_OP_CMPS_F  */
  YYSYMBOL_T_OP_ABSNEG_F = 94,             /* T_OP_ABSNEG_F  */
  YYSYMBOL_T_OP_CMPV_F = 95,               /* T_OP_CMPV_F  */
  YYSYMBOL_T_OP_FLOOR_F = 96,              /* T_OP_FLOOR_F  */
  YYSYMBOL_T_OP_CEIL_F = 97,               /* T_OP_CEIL_F  */
  YYSYMBOL_T_OP_RNDNE_F = 98,              /* T_OP_RNDNE_F  */
  YYSYMBOL_T_OP_RNDAZ_F = 99,              /* T_OP_RNDAZ_F  */
  YYSYMBOL_T_OP_TRUNC_F = 100,             /* T_OP_TRUNC_F  */
  YYSYMBOL_T_OP_ADD_U = 101,               /* T_OP_ADD_U  */
  YYSYMBOL_T_OP_ADD_S = 102,               /* T_OP_ADD_S  */
  YYSYMBOL_T_OP_SUB_U = 103,               /* T_OP_SUB_U  */
  YYSYMBOL_T_OP_SUB_S = 104,               /* T_OP_SUB_S  */
  YYSYMBOL_T_OP_CMPS_U = 105,              /* T_OP_CMPS_U  */
  YYSYMBOL_T_OP_CMPS_S = 106,              /* T_OP_CMPS_S  */
  YYSYMBOL_T_OP_MIN_U = 107,               /* T_OP_MIN_U  */
  YYSYMBOL_T_OP_MIN_S = 108,               /* T_OP_MIN_S  */
  YYSYMBOL_T_OP_MAX_U = 109,               /* T_OP_MAX_U  */
  YYSYMBOL_T_OP_MAX_S = 110,               /* T_OP_MAX_S  */
  YYSYMBOL_T_OP_ABSNEG_S = 111,            /* T_OP_ABSNEG_S  */
  YYSYMBOL_T_OP_AND_B = 112,               /* T_OP_AND_B  */
  YYSYMBOL_T_OP_OR_B = 113,                /* T_OP_OR_B  */
  YYSYMBOL_T_OP_NOT_B = 114,               /* T_OP_NOT_B  */
  YYSYMBOL_T_OP_XOR_B = 115,               /* T_OP_XOR_B  */
  YYSYMBOL_T_OP_CMPV_U = 116,              /* T_OP_CMPV_U  */
  YYSYMBOL_T_OP_CMPV_S = 117,              /* T_OP_CMPV_S  */
  YYSYMBOL_T_OP_MUL_U24 = 118,             /* T_OP_MUL_U24  */
  YYSYMBOL_T_OP_MUL_S24 = 119,             /* T_OP_MUL_S24  */
  YYSYMBOL_T_OP_MULL_U = 120,              /* T_OP_MULL_U  */
  YYSYMBOL_T_OP_BFREV_B = 121,             /* T_OP_BFREV_B  */
  YYSYMBOL_T_OP_CLZ_S = 122,               /* T_OP_CLZ_S  */
  YYSYMBOL_T_OP_CLZ_B = 123,               /* T_OP_CLZ_B  */
  YYSYMBOL_T_OP_SHL_B = 124,               /* T_OP_SHL_B  */
  YYSYMBOL_T_OP_SHR_B = 125,               /* T_OP_SHR_B  */
  YYSYMBOL_T_OP_ASHR_B = 126,              /* T_OP_ASHR_B  */
  YYSYMBOL_T_OP_BARY_F = 127,              /* T_OP_BARY_F  */
  YYSYMBOL_T_OP_MGEN_B = 128,              /* T_OP_MGEN_B  */
  YYSYMBOL_T_OP_GETBIT_B = 129,            /* T_OP_GETBIT_B  */
  YYSYMBOL_T_OP_SETRM = 130,               /* T_OP_SETRM  */
  YYSYMBOL_T_OP_CBITS_B = 131,             /* T_OP_CBITS_B  */
  YYSYMBOL_T_OP_SHB = 132,                 /* T_OP_SHB  */
  YYSYMBOL_T_OP_MSAD = 133,                /* T_OP_MSAD  */
  YYSYMBOL_T_OP_MAD_U16 = 134,             /* T_OP_MAD_U16  */
  YYSYMBOL_T_OP_MADSH_U16 = 135,           /* T_OP_MADSH_U16  */
  YYSYMBOL_T_OP_MAD_S16 = 136,             /* T_OP_MAD_S16  */
  YYSYMBOL_T_OP_MADSH_M16 = 137,           /* T_OP_MADSH_M16  */
  YYSYMBOL_T_OP_MAD_U24 = 138,             /* T_OP_MAD_U24  */
  YYSYMBOL_T_OP_MAD_S24 = 139,             /* T_OP_MAD_S24  */
  YYSYMBOL_T_OP_MAD_F16 = 140,             /* T_OP_MAD_F16  */
  YYSYMBOL_T_OP_MAD_F32 = 141,             /* T_OP_MAD_F32  */
  YYSYMBOL_T_OP_SEL_B16 = 142,             /* T_OP_SEL_B16  */
  YYSYMBOL_T_OP_SEL_B32 = 143,             /* T_OP_SEL_B32  */
  YYSYMBOL_T_OP_SEL_S16 = 144,             /* T_OP_SEL_S16  */
  YYSYMBOL_T_OP_SEL_S32 = 145,             /* T_OP_SEL_S32  */
  YYSYMBOL_T_OP_SEL_F16 = 146,             /* T_OP_SEL_F16  */
  YYSYMBOL_T_OP_SEL_F32 = 147,             /* T_OP_SEL_F32  */
  YYSYMBOL_T_OP_SAD_S16 = 148,             /* T_OP_SAD_S16  */
  YYSYMBOL_T_OP_SAD_S32 = 149,             /* T_OP_SAD_S32  */
  YYSYMBOL_T_OP_SHLG_B16 = 150,            /* T_OP_SHLG_B16  */
  YYSYMBOL_T_OP_RCP = 151,                 /* T_OP_RCP  */
  YYSYMBOL_T_OP_RSQ = 152,                 /* T_OP_RSQ  */
  YYSYMBOL_T_OP_LOG2 = 153,                /* T_OP_LOG2  */
  YYSYMBOL_T_OP_EXP2 = 154,                /* T_OP_EXP2  */
  YYSYMBOL_T_OP_SIN = 155,                 /* T_OP_SIN  */
  YYSYMBOL_T_OP_COS = 156,                 /* T_OP_COS  */
  YYSYMBOL_T_OP_SQRT = 157,                /* T_OP_SQRT  */
  YYSYMBOL_T_OP_HRSQ = 158,                /* T_OP_HRSQ  */
  YYSYMBOL_T_OP_HLOG2 = 159,               /* T_OP_HLOG2  */
  YYSYMBOL_T_OP_HEXP2 = 160,               /* T_OP_HEXP2  */
  YYSYMBOL_T_OP_ISAM = 161,                /* T_OP_ISAM  */
  YYSYMBOL_T_OP_ISAML = 162,               /* T_OP_ISAML  */
  YYSYMBOL_T_OP_ISAMM = 163,               /* T_OP_ISAMM  */
  YYSYMBOL_T_OP_SAM = 164,                 /* T_OP_SAM  */
  YYSYMBOL_T_OP_SAMB = 165,                /* T_OP_SAMB  */
  YYSYMBOL_T_OP_SAML = 166,                /* T_OP_SAML  */
  YYSYMBOL_T_OP_SAMGQ = 167,               /* T_OP_SAMGQ  */
  YYSYMBOL_T_OP_GETLOD = 168,              /* T_OP_GETLOD  */
  YYSYMBOL_T_OP_CONV = 169,                /* T_OP_CONV  */
  YYSYMBOL_T_OP_CONVM = 170,               /* T_OP_CONVM  */
  YYSYMBOL_T_OP_GETSIZE = 171,             /* T_OP_GETSIZE  */
  YYSYMBOL_T_OP_GETBUF = 172,              /* T_OP_GETBUF  */
  YYSYMBOL_T_OP_GETPOS = 173,              /* T_OP_GETPOS  */
  YYSYMBOL_T_OP_GETINFO = 174,             /* T_OP_GETINFO  */
  YYSYMBOL_T_OP_DSX = 175,                 /* T_OP_DSX  */
  YYSYMBOL_T_OP_DSY = 176,                 /* T_OP_DSY  */
  YYSYMBOL_T_OP_GATHER4R = 177,            /* T_OP_GATHER4R  */
  YYSYMBOL_T_OP_GATHER4G = 178,            /* T_OP_GATHER4G  */
  YYSYMBOL_T_OP_GATHER4B = 179,            /* T_OP_GATHER4B  */
  YYSYMBOL_T_OP_GATHER4A = 180,            /* T_OP_GATHER4A  */
  YYSYMBOL_T_OP_SAMGP0 = 181,              /* T_OP_SAMGP0  */
  YYSYMBOL_T_OP_SAMGP1 = 182,              /* T_OP_SAMGP1  */
  YYSYMBOL_T_OP_SAMGP2 = 183,              /* T_OP_SAMGP2  */
  YYSYMBOL_T_OP_SAMGP3 = 184,              /* T_OP_SAMGP3  */
  YYSYMBOL_T_OP_DSXPP_1 = 185,             /* T_OP_DSXPP_1  */
  YYSYMBOL_T_OP_DSYPP_1 = 186,             /* T_OP_DSYPP_1  */
  YYSYMBOL_T_OP_RGETPOS = 187,             /* T_OP_RGETPOS  */
  YYSYMBOL_T_OP_RGETINFO = 188,            /* T_OP_RGETINFO  */
  YYSYMBOL_T_OP_LDG = 189,                 /* T_OP_LDG  */
  YYSYMBOL_T_OP_LDG_A = 190,               /* T_OP_LDG_A  */
  YYSYMBOL_T_OP_LDL = 191,                 /* T_OP_LDL  */
  YYSYMBOL_T_OP_LDP = 192,                 /* T_OP_LDP  */
  YYSYMBOL_T_OP_STG = 193,                 /* T_OP_STG  */
  YYSYMBOL_T_OP_STG_A = 194,               /* T_OP_STG_A  */
  YYSYMBOL_T_OP_STL = 195,                 /* T_OP_STL  */
  YYSYMBOL_T_OP_STP = 196,                 /* T_OP_STP  */
  YYSYMBOL_T_OP_LDIB = 197,                /* T_OP_LDIB  */
  YYSYMBOL_T_OP_G2L = 198,                 /* T_OP_G2L  */
  YYSYMBOL_T_OP_L2G = 199,                 /* T_OP_L2G  */
  YYSYMBOL_T_OP_PREFETCH = 200,            /* T_OP_PREFETCH  */
  YYSYMBOL_T_OP_LDLW = 201,                /* T_OP_LDLW  */
  YYSYMBOL_T_OP_STLW = 202,                /* T_OP_STLW  */
  YYSYMBOL_T_OP_RESFMT = 203,              /* T_OP_RESFMT  */
  YYSYMBOL_T_OP_RESINFO = 204,             /* T_OP_RESINFO  */
  YYSYMBOL_T_OP_ATOMIC_ADD = 205,          /* T_OP_ATOMIC_ADD  */
  YYSYMBOL_T_OP_ATOMIC_SUB = 206,          /* T_OP_ATOMIC_SUB  */
  YYSYMBOL_T_OP_ATOMIC_XCHG = 207,         /* T_OP_ATOMIC_XCHG  */
  YYSYMBOL_T_OP_ATOMIC_INC = 208,          /* T_OP_ATOMIC_INC  */
  YYSYMBOL_T_OP_ATOMIC_DEC = 209,          /* T_OP_ATOMIC_DEC  */
  YYSYMBOL_T_OP_ATOMIC_CMPXCHG = 210,      /* T_OP_ATOMIC_CMPXCHG  */
  YYSYMBOL_T_OP_ATOMIC_MIN = 211,          /* T_OP_ATOMIC_MIN  */
  YYSYMBOL_T_OP_ATOMIC_MAX = 212,          /* T_OP_ATOMIC_MAX  */
  YYSYMBOL_T_OP_ATOMIC_AND = 213,          /* T_OP_ATOMIC_AND  */
  YYSYMBOL_T_OP_ATOMIC_OR = 214,           /* T_OP_ATOMIC_OR  */
  YYSYMBOL_T_OP_ATOMIC_XOR = 215,          /* T_OP_ATOMIC_XOR  */
  YYSYMBOL_T_OP_RESINFO_B = 216,           /* T_OP_RESINFO_B  */
  YYSYMBOL_T_OP_LDIB_B = 217,              /* T_OP_LDIB_B  */
  YYSYMBOL_T_OP_STIB_B = 218,              /* T_OP_STIB_B  */
  YYSYMBOL_T_OP_ATOMIC_B_ADD = 219,        /* T_OP_ATOMIC_B_ADD  */
  YYSYMBOL_T_OP_ATOMIC_B_SUB = 220,        /* T_OP_ATOMIC_B_SUB  */
  YYSYMBOL_T_OP_ATOMIC_B_XCHG = 221,       /* T_OP_ATOMIC_B_XCHG  */
  YYSYMBOL_T_OP_ATOMIC_B_INC = 222,        /* T_OP_ATOMIC_B_INC  */
  YYSYMBOL_T_OP_ATOMIC_B_DEC = 223,        /* T_OP_ATOMIC_B_DEC  */
  YYSYMBOL_T_OP_ATOMIC_B_CMPXCHG = 224,    /* T_OP_ATOMIC_B_CMPXCHG  */
  YYSYMBOL_T_OP_ATOMIC_B_MIN = 225,        /* T_OP_ATOMIC_B_MIN  */
  YYSYMBOL_T_OP_ATOMIC_B_MAX = 226,        /* T_OP_ATOMIC_B_MAX  */
  YYSYMBOL_T_OP_ATOMIC_B_AND = 227,        /* T_OP_ATOMIC_B_AND  */
  YYSYMBOL_T_OP_ATOMIC_B_OR = 228,         /* T_OP_ATOMIC_B_OR  */
  YYSYMBOL_T_OP_ATOMIC_B_XOR = 229,        /* T_OP_ATOMIC_B_XOR  */
  YYSYMBOL_T_OP_LDGB = 230,                /* T_OP_LDGB  */
  YYSYMBOL_T_OP_STGB = 231,                /* T_OP_STGB  */
  YYSYMBOL_T_OP_STIB = 232,                /* T_OP_STIB  */
  YYSYMBOL_T_OP_LDC = 233,                 /* T_OP_LDC  */
  YYSYMBOL_T_OP_LDLV = 234,                /* T_OP_LDLV  */
  YYSYMBOL_T_OP_GETSPID = 235,             /* T_OP_GETSPID  */
  YYSYMBOL_T_OP_GETWID = 236,              /* T_OP_GETWID  */
  YYSYMBOL_T_OP_BAR = 237,                 /* T_OP_BAR  */
  YYSYMBOL_T_OP_FENCE = 238,               /* T_OP_FENCE  */
  YYSYMBOL_T_TYPE_F16 = 239,               /* T_TYPE_F16  */
  YYSYMBOL_T_TYPE_F32 = 240,               /* T_TYPE_F32  */
  YYSYMBOL_T_TYPE_U16 = 241,               /* T_TYPE_U16  */
  YYSYMBOL_T_TYPE_U32 = 242,               /* T_TYPE_U32  */
  YYSYMBOL_T_TYPE_S16 = 243,               /* T_TYPE_S16  */
  YYSYMBOL_T_TYPE_S32 = 244,               /* T_TYPE_S32  */
  YYSYMBOL_T_TYPE_U8 = 245,                /* T_TYPE_U8  */
  YYSYMBOL_T_TYPE_S8 = 246,                /* T_TYPE_S8  */
  YYSYMBOL_T_UNTYPED = 247,                /* T_UNTYPED  */
  YYSYMBOL_T_TYPED = 248,                  /* T_TYPED  */
  YYSYMBOL_T_1D = 249,                     /* T_1D  */
  YYSYMBOL_T_2D = 250,                     /* T_2D  */
  YYSYMBOL_T_3D = 251,                     /* T_3D  */
  YYSYMBOL_T_4D = 252,                     /* T_4D  */
  YYSYMBOL_T_LT = 253,                     /* T_LT  */
  YYSYMBOL_T_LE = 254,                     /* T_LE  */
  YYSYMBOL_T_GT = 255,                     /* T_GT  */
  YYSYMBOL_T_GE = 256,                     /* T_GE  */
  YYSYMBOL_T_EQ = 257,                     /* T_EQ  */
  YYSYMBOL_T_NE = 258,                     /* T_NE  */
  YYSYMBOL_T_S2EN = 259,                   /* T_S2EN  */
  YYSYMBOL_T_SAMP = 260,                   /* T_SAMP  */
  YYSYMBOL_T_TEX = 261,                    /* T_TEX  */
  YYSYMBOL_T_BASE = 262,                   /* T_BASE  */
  YYSYMBOL_T_OFFSET = 263,                 /* T_OFFSET  */
  YYSYMBOL_T_UNIFORM = 264,                /* T_UNIFORM  */
  YYSYMBOL_T_NONUNIFORM = 265,             /* T_NONUNIFORM  */
  YYSYMBOL_T_IMM = 266,                    /* T_IMM  */
  YYSYMBOL_T_NAN = 267,                    /* T_NAN  */
  YYSYMBOL_T_INF = 268,                    /* T_INF  */
  YYSYMBOL_T_A0 = 269,                     /* T_A0  */
  YYSYMBOL_T_A1 = 270,                     /* T_A1  */
  YYSYMBOL_T_P0 = 271,                     /* T_P0  */
  YYSYMBOL_T_W = 272,                      /* T_W  */
  YYSYMBOL_T_CAT1_TYPE_TYPE = 273,         /* T_CAT1_TYPE_TYPE  */
  YYSYMBOL_274_ = 274,                     /* '-'  */
  YYSYMBOL_275_ = 275,                     /* ','  */
  YYSYMBOL_276_ = 276,                     /* '('  */
  YYSYMBOL_277_ = 277,                     /* ')'  */
  YYSYMBOL_278_ = 278,                     /* '='  */
  YYSYMBOL_279_ = 279,                     /* ':'  */
  YYSYMBOL_280_ = 280,                     /* '!'  */
  YYSYMBOL_281_ = 281,                     /* '#'  */
  YYSYMBOL_282_ = 282,                     /* '.'  */
  YYSYMBOL_283_a_ = 283,                   /* 'a'  */
  YYSYMBOL_284_o_ = 284,                   /* 'o'  */
  YYSYMBOL_285_p_ = 285,                   /* 'p'  */
  YYSYMBOL_286_s_ = 286,                   /* 's'  */
  YYSYMBOL_287_ = 287,                     /* '+'  */
  YYSYMBOL_288_ = 288,                     /* '<'  */
  YYSYMBOL_289_g_ = 289,                   /* 'g'  */
  YYSYMBOL_290_ = 290,                     /* '['  */
  YYSYMBOL_291_ = 291,                     /* ']'  */
  YYSYMBOL_292_l_ = 292,                   /* 'l'  */
  YYSYMBOL_293_w_ = 293,                   /* 'w'  */
  YYSYMBOL_294_r_ = 294,                   /* 'r'  */
  YYSYMBOL_295_ = 295,                     /* '>'  */
  YYSYMBOL_296_c_ = 296,                   /* 'c'  */
  YYSYMBOL_297_h_ = 297,                   /* 'h'  */
  YYSYMBOL_YYACCEPT = 298,                 /* $accept  */
  YYSYMBOL_shader = 299,                   /* shader  */
  YYSYMBOL_300_1 = 300,                    /* $@1  */
  YYSYMBOL_headers = 301,                  /* headers  */
  YYSYMBOL_header = 302,                   /* header  */
  YYSYMBOL_const_val = 303,                /* const_val  */
  YYSYMBOL_localsize_header = 304,         /* localsize_header  */
  YYSYMBOL_const_header = 305,             /* const_header  */
  YYSYMBOL_buf_header_addr_reg = 306,      /* buf_header_addr_reg  */
  YYSYMBOL_buf_header = 307,               /* buf_header  */
  YYSYMBOL_308_2 = 308,                    /* $@2  */
  YYSYMBOL_invocationid_header = 309,      /* invocationid_header  */
  YYSYMBOL_wgid_header = 310,              /* wgid_header  */
  YYSYMBOL_numwg_header = 311,             /* numwg_header  */
  YYSYMBOL_branchstack_header = 312,       /* branchstack_header  */
  YYSYMBOL_pvtmem_header = 313,            /* pvtmem_header  */
  YYSYMBOL_in_header = 314,                /* in_header  */
  YYSYMBOL_out_header = 315,               /* out_header  */
  YYSYMBOL_tex_header = 316,               /* tex_header  */
  YYSYMBOL_iflag = 317,                    /* iflag  */
  YYSYMBOL_iflags = 318,                   /* iflags  */
  YYSYMBOL_instrs = 319,                   /* instrs  */
  YYSYMBOL_instr = 320,                    /* instr  */
  YYSYMBOL_label = 321,                    /* label  */
  YYSYMBOL_cat0_src1 = 322,                /* cat0_src1  */
  YYSYMBOL_cat0_src2 = 323,                /* cat0_src2  */
  YYSYMBOL_cat0_immed = 324,               /* cat0_immed  */
  YYSYMBOL_cat0_instr = 325,               /* cat0_instr  */
  YYSYMBOL_326_3 = 326,                    /* $@3  */
  YYSYMBOL_327_4 = 327,                    /* $@4  */
  YYSYMBOL_328_5 = 328,                    /* $@5  */
  YYSYMBOL_329_6 = 329,                    /* $@6  */
  YYSYMBOL_330_7 = 330,                    /* $@7  */
  YYSYMBOL_331_8 = 331,                    /* $@8  */
  YYSYMBOL_332_9 = 332,                    /* $@9  */
  YYSYMBOL_333_10 = 333,                   /* $@10  */
  YYSYMBOL_334_11 = 334,                   /* $@11  */
  YYSYMBOL_335_12 = 335,                   /* $@12  */
  YYSYMBOL_336_13 = 336,                   /* $@13  */
  YYSYMBOL_337_14 = 337,                   /* $@14  */
  YYSYMBOL_338_15 = 338,                   /* $@15  */
  YYSYMBOL_339_16 = 339,                   /* $@16  */
  YYSYMBOL_340_17 = 340,                   /* $@17  */
  YYSYMBOL_cat1_opc = 341,                 /* cat1_opc  */
  YYSYMBOL_cat1_src = 342,                 /* cat1_src  */
  YYSYMBOL_cat1_movmsk = 343,              /* cat1_movmsk  */
  YYSYMBOL_344_18 = 344,                   /* $@18  */
  YYSYMBOL_cat1_mova1 = 345,               /* cat1_mova1  */
  YYSYMBOL_346_19 = 346,                   /* $@19  */
  YYSYMBOL_cat1_mova = 347,                /* cat1_mova  */
  YYSYMBOL_348_20 = 348,                   /* $@20  */
  YYSYMBOL_cat1_swz = 349,                 /* cat1_swz  */
  YYSYMBOL_350_21 = 350,                   /* $@21  */
  YYSYMBOL_cat1_gat = 351,                 /* cat1_gat  */
  YYSYMBOL_352_22 = 352,                   /* $@22  */
  YYSYMBOL_cat1_sct = 353,                 /* cat1_sct  */
  YYSYMBOL_354_23 = 354,                   /* $@23  */
  YYSYMBOL_cat1_instr = 355,               /* cat1_instr  */
  YYSYMBOL_cat2_opc_1src = 356,            /* cat2_opc_1src  */
  YYSYMBOL_cat2_opc_2src_cnd = 357,        /* cat2_opc_2src_cnd  */
  YYSYMBOL_cat2_opc_2src = 358,            /* cat2_opc_2src  */
  YYSYMBOL_cond = 359,                     /* cond  */
  YYSYMBOL_cat2_instr = 360,               /* cat2_instr  */
  YYSYMBOL_cat3_opc = 361,                 /* cat3_opc  */
  YYSYMBOL_cat3_instr = 362,               /* cat3_instr  */
  YYSYMBOL_363_24 = 363,                   /* $@24  */
  YYSYMBOL_cat4_opc = 364,                 /* cat4_opc  */
  YYSYMBOL_cat4_instr = 365,               /* cat4_instr  */
  YYSYMBOL_cat5_opc_dsxypp = 366,          /* cat5_opc_dsxypp  */
  YYSYMBOL_cat5_opc = 367,                 /* cat5_opc  */
  YYSYMBOL_cat5_flag = 368,                /* cat5_flag  */
  YYSYMBOL_cat5_flags = 369,               /* cat5_flags  */
  YYSYMBOL_cat5_samp = 370,                /* cat5_samp  */
  YYSYMBOL_cat5_tex = 371,                 /* cat5_tex  */
  YYSYMBOL_cat5_type = 372,                /* cat5_type  */
  YYSYMBOL_cat5_a1 = 373,                  /* cat5_a1  */
  YYSYMBOL_cat5_instr = 374,               /* cat5_instr  */
  YYSYMBOL_cat6_typed = 375,               /* cat6_typed  */
  YYSYMBOL_cat6_dim = 376,                 /* cat6_dim  */
  YYSYMBOL_cat6_type = 377,                /* cat6_type  */
  YYSYMBOL_cat6_imm_offset = 378,          /* cat6_imm_offset  */
  YYSYMBOL_cat6_offset = 379,              /* cat6_offset  */
  YYSYMBOL_cat6_dst_offset = 380,          /* cat6_dst_offset  */
  YYSYMBOL_cat6_immed = 381,               /* cat6_immed  */
  YYSYMBOL_cat6_stg_ldg_a6xx_offset = 382, /* cat6_stg_ldg_a6xx_offset  */
  YYSYMBOL_cat6_load = 383,                /* cat6_load  */
  YYSYMBOL_384_25 = 384,                   /* $@25  */
  YYSYMBOL_385_26 = 385,                   /* $@26  */
  YYSYMBOL_386_27 = 386,                   /* $@27  */
  YYSYMBOL_387_28 = 387,                   /* $@28  */
  YYSYMBOL_388_29 = 388,                   /* $@29  */
  YYSYMBOL_389_30 = 389,                   /* $@30  */
  YYSYMBOL_390_31 = 390,                   /* $@31  */
  YYSYMBOL_cat6_store = 391,               /* cat6_store  */
  YYSYMBOL_392_32 = 392,                   /* $@32  */
  YYSYMBOL_393_33 = 393,                   /* $@33  */
  YYSYMBOL_394_34 = 394,                   /* $@34  */
  YYSYMBOL_395_35 = 395,                   /* $@35  */
  YYSYMBOL_396_36 = 396,                   /* $@36  */
  YYSYMBOL_cat6_loadib = 397,              /* cat6_loadib  */
  YYSYMBOL_398_37 = 398,                   /* $@37  */
  YYSYMBOL_cat6_storeib = 399,             /* cat6_storeib  */
  YYSYMBOL_400_38 = 400,                   /* $@38  */
  YYSYMBOL_cat6_prefetch = 401,            /* cat6_prefetch  */
  YYSYMBOL_402_39 = 402,                   /* $@39  */
  YYSYMBOL_cat6_atomic_opc = 403,          /* cat6_atomic_opc  */
  YYSYMBOL_cat6_atomic_g = 404,            /* cat6_atomic_g  */
  YYSYMBOL_cat6_atomic_l = 405,            /* cat6_atomic_l  */
  YYSYMBOL_cat6_atomic = 406,              /* cat6_atomic  */
  YYSYMBOL_cat6_ibo_opc_1src = 407,        /* cat6_ibo_opc_1src  */
  YYSYMBOL_cat6_ibo_opc_ldgb = 408,        /* cat6_ibo_opc_ldgb  */
  YYSYMBOL_cat6_ibo_opc_stgb = 409,        /* cat6_ibo_opc_stgb  */
  YYSYMBOL_cat6_ibo = 410,                 /* cat6_ibo  */
  YYSYMBOL_411_40 = 411,                   /* $@40  */
  YYSYMBOL_cat6_id_opc = 412,              /* cat6_id_opc  */
  YYSYMBOL_cat6_id = 413,                  /* cat6_id  */
  YYSYMBOL_cat6_bindless_base = 414,       /* cat6_bindless_base  */
  YYSYMBOL_cat6_bindless_mode = 415,       /* cat6_bindless_mode  */
  YYSYMBOL_cat6_reg_or_immed = 416,        /* cat6_reg_or_immed  */
  YYSYMBOL_cat6_bindless_ibo_opc_1src = 417, /* cat6_bindless_ibo_opc_1src  */
  YYSYMBOL_cat6_bindless_ibo_opc_2src = 418, /* cat6_bindless_ibo_opc_2src  */
  YYSYMBOL_cat6_bindless_ibo_opc_2src_dst = 419, /* cat6_bindless_ibo_opc_2src_dst  */
  YYSYMBOL_cat6_bindless_ibo = 420,        /* cat6_bindless_ibo  */
  YYSYMBOL_cat6_bindless_ldc_opc = 421,    /* cat6_bindless_ldc_opc  */
  YYSYMBOL_cat6_bindless_ldc = 422,        /* cat6_bindless_ldc  */
  YYSYMBOL_cat6_todo = 423,                /* cat6_todo  */
  YYSYMBOL_cat6_instr = 424,               /* cat6_instr  */
  YYSYMBOL_cat7_scope = 425,               /* cat7_scope  */
  YYSYMBOL_cat7_scopes = 426,              /* cat7_scopes  */
  YYSYMBOL_cat7_barrier = 427,             /* cat7_barrier  */
  YYSYMBOL_428_41 = 428,                   /* $@41  */
  YYSYMBOL_429_42 = 429,                   /* $@42  */
  YYSYMBOL_cat7_instr = 430,               /* cat7_instr  */
  YYSYMBOL_src = 431,                      /* src  */
  YYSYMBOL_dst = 432,                      /* dst  */
  YYSYMBOL_const = 433,                    /* const  */
  YYSYMBOL_dst_reg_flag = 434,             /* dst_reg_flag  */
  YYSYMBOL_dst_reg_flags = 435,            /* dst_reg_flags  */
  YYSYMBOL_dst_reg = 436,                  /* dst_reg  */
  YYSYMBOL_src_reg_flag = 437,             /* src_reg_flag  */
  YYSYMBOL_src_reg_flags = 438,            /* src_reg_flags  */
  YYSYMBOL_src_reg = 439,                  /* src_reg  */
  YYSYMBOL_src_const = 440,                /* src_const  */
  YYSYMBOL_src_reg_or_const = 441,         /* src_reg_or_const  */
  YYSYMBOL_src_reg_or_const_or_rel = 442,  /* src_reg_or_const_or_rel  */
  YYSYMBOL_src_reg_or_const_or_rel_or_imm = 443, /* src_reg_or_const_or_rel_or_imm  */
  YYSYMBOL_src_reg_or_rel_or_imm = 444,    /* src_reg_or_rel_or_imm  */
  YYSYMBOL_offset = 445,                   /* offset  */
  YYSYMBOL_relative_gpr_src = 446,         /* relative_gpr_src  */
  YYSYMBOL_relative_gpr_dst = 447,         /* relative_gpr_dst  */
  YYSYMBOL_relative_const = 448,           /* relative_const  */
  YYSYMBOL_relative = 449,                 /* relative  */
  YYSYMBOL_immediate_cat1 = 450,           /* immediate_cat1  */
  YYSYMBOL_immediate = 451,                /* immediate  */
  YYSYMBOL_flut_immed = 452,               /* flut_immed  */
  YYSYMBOL_integer = 453,                  /* integer  */
  YYSYMBOL_float = 454,                    /* float  */
  YYSYMBOL_type = 455                      /* type  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;


/* Second part of user prologue.  */
#line 307 "../src/freedreno/ir3/ir3_parser.y"

#if YYDEBUG
static void print_token(FILE *file, int type, YYSTYPE value)
{
	fprintf(file, "\ntype: %d\n", type);
}

#define YYPRINT(file, type, value) print_token(file, type, value)
#endif

#line 839 "src/freedreno/ir3/ir3_parser.c"


#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1153

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  298
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  158
/* YYNRULES -- Number of rules.  */
#define YYNRULES  481
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1017

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   528


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   280,     2,   281,     2,     2,     2,     2,
     276,   277,     2,   287,   275,   274,   282,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   279,     2,
     288,   278,   295,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   290,     2,   291,     2,     2,     2,   283,     2,   296,
       2,     2,     2,   289,   297,     2,     2,     2,   292,     2,
       2,   284,   285,     2,   294,   286,     2,     2,     2,   293,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   644,   644,   644,   646,   647,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   661,   662,   663,
     664,   666,   672,   677,   685,   687,   687,   693,   699,   706,
     713,   722,   724,   727,   729,   731,   738,   739,   740,   741,
     742,   743,   744,   746,   747,   749,   750,   752,   753,   754,
     755,   756,   757,   758,   759,   760,   762,   764,   765,   767,
     768,   770,   771,   773,   774,   774,   775,   775,   776,   776,
     777,   777,   778,   778,   779,   779,   780,   780,   781,   781,
     782,   782,   783,   784,   784,   785,   786,   787,   788,   789,
     790,   791,   791,   792,   793,   794,   795,   796,   796,   797,
     798,   798,   799,   800,   800,   801,   801,   802,   804,   807,
     811,   812,   814,   814,   823,   823,   830,   830,   837,   837,
     839,   839,   841,   841,   844,   845,   846,   847,   848,   849,
     850,   851,   853,   854,   855,   856,   857,   858,   859,   860,
     861,   862,   863,   864,   865,   866,   868,   869,   870,   871,
     872,   873,   875,   876,   877,   878,   879,   880,   881,   882,
     883,   884,   885,   886,   887,   888,   889,   890,   891,   892,
     893,   894,   895,   896,   897,   898,   899,   900,   902,   903,
     904,   905,   906,   907,   909,   910,   911,   913,   914,   915,
     916,   917,   918,   919,   920,   921,   922,   923,   924,   925,
     926,   927,   928,   930,   931,   931,   933,   934,   935,   936,
     937,   938,   939,   940,   941,   942,   944,   946,   947,   949,
     950,   951,   952,   953,   954,   955,   956,   957,   958,   959,
     960,   961,   962,   963,   964,   965,   966,   967,   968,   969,
     970,   971,   972,   973,   974,   976,   977,   978,   979,   980,
     981,   982,   983,   984,   985,   987,   988,   989,   990,   992,
     993,   994,   995,   996,   997,   998,   999,  1000,  1001,  1002,
    1003,  1004,  1005,  1006,  1008,  1009,  1011,  1012,  1013,  1014,
    1016,  1017,  1018,  1019,  1020,  1021,  1023,  1026,  1031,  1037,
    1037,  1038,  1038,  1039,  1039,  1040,  1040,  1041,  1041,  1042,
    1042,  1042,  1046,  1046,  1047,  1047,  1048,  1048,  1049,  1049,
    1050,  1050,  1052,  1052,  1053,  1053,  1055,  1055,  1057,  1058,
    1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,  1067,  1069,
    1073,  1075,  1076,  1078,  1080,  1081,  1083,  1084,  1085,  1085,
    1088,  1089,  1091,  1093,  1094,  1096,  1097,  1098,  1100,  1101,
    1103,  1105,  1106,  1107,  1108,  1109,  1110,  1111,  1112,  1113,
    1114,  1115,  1116,  1118,  1120,  1121,  1122,  1124,  1126,  1133,
    1134,  1135,  1137,  1138,  1139,  1140,  1141,  1142,  1143,  1144,
    1145,  1146,  1147,  1149,  1150,  1151,  1152,  1154,  1155,  1157,
    1157,  1158,  1158,  1160,  1162,  1163,  1164,  1165,  1167,  1168,
    1169,  1170,  1172,  1174,  1175,  1176,  1177,  1178,  1180,  1181,
    1184,  1185,  1187,  1188,  1189,  1190,  1192,  1193,  1195,  1196,
    1198,  1199,  1201,  1202,  1204,  1205,  1206,  1208,  1209,  1210,
    1212,  1213,  1214,  1216,  1217,  1218,  1220,  1221,  1223,  1224,
    1226,  1227,  1229,  1230,  1236,  1237,  1238,  1239,  1240,  1241,
    1242,  1244,  1245,  1246,  1247,  1248,  1251,  1252,  1253,  1254,
    1255,  1256,  1257,  1258,  1259,  1260,  1261,  1262,  1264,  1265,
    1266,  1267,  1269,  1270,  1272,  1273,  1274,  1275,  1276,  1277,
    1278,  1279
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "T_INT", "T_HEX",
  "T_FLOAT", "T_IDENTIFIER", "T_REGISTER", "T_CONSTANT", "T_A_LOCALSIZE",
  "T_A_CONST", "T_A_BUF", "T_A_INVOCATIONID", "T_A_WGID", "T_A_NUMWG",
  "T_A_BRANCHSTACK", "T_A_IN", "T_A_OUT", "T_A_TEX", "T_A_PVTMEM",
  "T_ABSNEG", "T_NEG", "T_ABS", "T_R", "T_HR", "T_HC", "T_EVEN",
  "T_POS_INFINITY", "T_NEG_INFINITY", "T_EI", "T_WRMASK", "T_FLUT_0_0",
  "T_FLUT_0_5", "T_FLUT_1_0", "T_FLUT_2_0", "T_FLUT_E", "T_FLUT_PI",
  "T_FLUT_INV_PI", "T_FLUT_INV_LOG2_E", "T_FLUT_LOG2_E",
  "T_FLUT_INV_LOG2_10", "T_FLUT_LOG2_10", "T_FLUT_4_0", "T_SY", "T_SS",
  "T_JP", "T_SAT", "T_RPT", "T_UL", "T_NOP", "T_OP_NOP", "T_OP_BR",
  "T_OP_BRAO", "T_OP_BRAA", "T_OP_BRAC", "T_OP_BANY", "T_OP_BALL",
  "T_OP_BRAX", "T_OP_JUMP", "T_OP_CALL", "T_OP_RET", "T_OP_KILL",
  "T_OP_END", "T_OP_EMIT", "T_OP_CUT", "T_OP_CHMASK", "T_OP_CHSH",
  "T_OP_FLOW_REV", "T_OP_BKT", "T_OP_STKS", "T_OP_STKR", "T_OP_XSET",
  "T_OP_XCLR", "T_OP_GETONE", "T_OP_DBG", "T_OP_SHPS", "T_OP_SHPE",
  "T_OP_PREDT", "T_OP_PREDF", "T_OP_PREDE", "T_OP_MOVMSK", "T_OP_MOVA1",
  "T_OP_MOVA", "T_OP_MOV", "T_OP_COV", "T_OP_SWZ", "T_OP_GAT", "T_OP_SCT",
  "T_OP_ADD_F", "T_OP_MIN_F", "T_OP_MAX_F", "T_OP_MUL_F", "T_OP_SIGN_F",
  "T_OP_CMPS_F", "T_OP_ABSNEG_F", "T_OP_CMPV_F", "T_OP_FLOOR_F",
  "T_OP_CEIL_F", "T_OP_RNDNE_F", "T_OP_RNDAZ_F", "T_OP_TRUNC_F",
  "T_OP_ADD_U", "T_OP_ADD_S", "T_OP_SUB_U", "T_OP_SUB_S", "T_OP_CMPS_U",
  "T_OP_CMPS_S", "T_OP_MIN_U", "T_OP_MIN_S", "T_OP_MAX_U", "T_OP_MAX_S",
  "T_OP_ABSNEG_S", "T_OP_AND_B", "T_OP_OR_B", "T_OP_NOT_B", "T_OP_XOR_B",
  "T_OP_CMPV_U", "T_OP_CMPV_S", "T_OP_MUL_U24", "T_OP_MUL_S24",
  "T_OP_MULL_U", "T_OP_BFREV_B", "T_OP_CLZ_S", "T_OP_CLZ_B", "T_OP_SHL_B",
  "T_OP_SHR_B", "T_OP_ASHR_B", "T_OP_BARY_F", "T_OP_MGEN_B",
  "T_OP_GETBIT_B", "T_OP_SETRM", "T_OP_CBITS_B", "T_OP_SHB", "T_OP_MSAD",
  "T_OP_MAD_U16", "T_OP_MADSH_U16", "T_OP_MAD_S16", "T_OP_MADSH_M16",
  "T_OP_MAD_U24", "T_OP_MAD_S24", "T_OP_MAD_F16", "T_OP_MAD_F32",
  "T_OP_SEL_B16", "T_OP_SEL_B32", "T_OP_SEL_S16", "T_OP_SEL_S32",
  "T_OP_SEL_F16", "T_OP_SEL_F32", "T_OP_SAD_S16", "T_OP_SAD_S32",
  "T_OP_SHLG_B16", "T_OP_RCP", "T_OP_RSQ", "T_OP_LOG2", "T_OP_EXP2",
  "T_OP_SIN", "T_OP_COS", "T_OP_SQRT", "T_OP_HRSQ", "T_OP_HLOG2",
  "T_OP_HEXP2", "T_OP_ISAM", "T_OP_ISAML", "T_OP_ISAMM", "T_OP_SAM",
  "T_OP_SAMB", "T_OP_SAML", "T_OP_SAMGQ", "T_OP_GETLOD", "T_OP_CONV",
  "T_OP_CONVM", "T_OP_GETSIZE", "T_OP_GETBUF", "T_OP_GETPOS",
  "T_OP_GETINFO", "T_OP_DSX", "T_OP_DSY", "T_OP_GATHER4R", "T_OP_GATHER4G",
  "T_OP_GATHER4B", "T_OP_GATHER4A", "T_OP_SAMGP0", "T_OP_SAMGP1",
  "T_OP_SAMGP2", "T_OP_SAMGP3", "T_OP_DSXPP_1", "T_OP_DSYPP_1",
  "T_OP_RGETPOS", "T_OP_RGETINFO", "T_OP_LDG", "T_OP_LDG_A", "T_OP_LDL",
  "T_OP_LDP", "T_OP_STG", "T_OP_STG_A", "T_OP_STL", "T_OP_STP",
  "T_OP_LDIB", "T_OP_G2L", "T_OP_L2G", "T_OP_PREFETCH", "T_OP_LDLW",
  "T_OP_STLW", "T_OP_RESFMT", "T_OP_RESINFO", "T_OP_ATOMIC_ADD",
  "T_OP_ATOMIC_SUB", "T_OP_ATOMIC_XCHG", "T_OP_ATOMIC_INC",
  "T_OP_ATOMIC_DEC", "T_OP_ATOMIC_CMPXCHG", "T_OP_ATOMIC_MIN",
  "T_OP_ATOMIC_MAX", "T_OP_ATOMIC_AND", "T_OP_ATOMIC_OR",
  "T_OP_ATOMIC_XOR", "T_OP_RESINFO_B", "T_OP_LDIB_B", "T_OP_STIB_B",
  "T_OP_ATOMIC_B_ADD", "T_OP_ATOMIC_B_SUB", "T_OP_ATOMIC_B_XCHG",
  "T_OP_ATOMIC_B_INC", "T_OP_ATOMIC_B_DEC", "T_OP_ATOMIC_B_CMPXCHG",
  "T_OP_ATOMIC_B_MIN", "T_OP_ATOMIC_B_MAX", "T_OP_ATOMIC_B_AND",
  "T_OP_ATOMIC_B_OR", "T_OP_ATOMIC_B_XOR", "T_OP_LDGB", "T_OP_STGB",
  "T_OP_STIB", "T_OP_LDC", "T_OP_LDLV", "T_OP_GETSPID", "T_OP_GETWID",
  "T_OP_BAR", "T_OP_FENCE", "T_TYPE_F16", "T_TYPE_F32", "T_TYPE_U16",
  "T_TYPE_U32", "T_TYPE_S16", "T_TYPE_S32", "T_TYPE_U8", "T_TYPE_S8",
  "T_UNTYPED", "T_TYPED", "T_1D", "T_2D", "T_3D", "T_4D", "T_LT", "T_LE",
  "T_GT", "T_GE", "T_EQ", "T_NE", "T_S2EN", "T_SAMP", "T_TEX", "T_BASE",
  "T_OFFSET", "T_UNIFORM", "T_NONUNIFORM", "T_IMM", "T_NAN", "T_INF",
  "T_A0", "T_A1", "T_P0", "T_W", "T_CAT1_TYPE_TYPE", "'-'", "','", "'('",
  "')'", "'='", "':'", "'!'", "'#'", "'.'", "'a'", "'o'", "'p'", "'s'",
  "'+'", "'<'", "'g'", "'['", "']'", "'l'", "'w'", "'r'", "'>'", "'c'",
  "'h'", "$accept", "shader", "$@1", "headers", "header", "const_val",
  "localsize_header", "const_header", "buf_header_addr_reg", "buf_header",
  "$@2", "invocationid_header", "wgid_header", "numwg_header",
  "branchstack_header", "pvtmem_header", "in_header", "out_header",
  "tex_header", "iflag", "iflags", "instrs", "instr", "label", "cat0_src1",
  "cat0_src2", "cat0_immed", "cat0_instr", "$@3", "$@4", "$@5", "$@6",
  "$@7", "$@8", "$@9", "$@10", "$@11", "$@12", "$@13", "$@14", "$@15",
  "$@16", "$@17", "cat1_opc", "cat1_src", "cat1_movmsk", "$@18",
  "cat1_mova1", "$@19", "cat1_mova", "$@20", "cat1_swz", "$@21",
  "cat1_gat", "$@22", "cat1_sct", "$@23", "cat1_instr", "cat2_opc_1src",
  "cat2_opc_2src_cnd", "cat2_opc_2src", "cond", "cat2_instr", "cat3_opc",
  "cat3_instr", "$@24", "cat4_opc", "cat4_instr", "cat5_opc_dsxypp",
  "cat5_opc", "cat5_flag", "cat5_flags", "cat5_samp", "cat5_tex",
  "cat5_type", "cat5_a1", "cat5_instr", "cat6_typed", "cat6_dim",
  "cat6_type", "cat6_imm_offset", "cat6_offset", "cat6_dst_offset",
  "cat6_immed", "cat6_stg_ldg_a6xx_offset", "cat6_load", "$@25", "$@26",
  "$@27", "$@28", "$@29", "$@30", "$@31", "cat6_store", "$@32", "$@33",
  "$@34", "$@35", "$@36", "cat6_loadib", "$@37", "cat6_storeib", "$@38",
  "cat6_prefetch", "$@39", "cat6_atomic_opc", "cat6_atomic_g",
  "cat6_atomic_l", "cat6_atomic", "cat6_ibo_opc_1src", "cat6_ibo_opc_ldgb",
  "cat6_ibo_opc_stgb", "cat6_ibo", "$@40", "cat6_id_opc", "cat6_id",
  "cat6_bindless_base", "cat6_bindless_mode", "cat6_reg_or_immed",
  "cat6_bindless_ibo_opc_1src", "cat6_bindless_ibo_opc_2src",
  "cat6_bindless_ibo_opc_2src_dst", "cat6_bindless_ibo",
  "cat6_bindless_ldc_opc", "cat6_bindless_ldc", "cat6_todo", "cat6_instr",
  "cat7_scope", "cat7_scopes", "cat7_barrier", "$@41", "$@42",
  "cat7_instr", "src", "dst", "const", "dst_reg_flag", "dst_reg_flags",
  "dst_reg", "src_reg_flag", "src_reg_flags", "src_reg", "src_const",
  "src_reg_or_const", "src_reg_or_const_or_rel",
  "src_reg_or_const_or_rel_or_imm", "src_reg_or_rel_or_imm", "offset",
  "relative_gpr_src", "relative_gpr_dst", "relative_const", "relative",
  "immediate_cat1", "immediate", "flut_immed", "integer", "float", "type", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,    45,    44,    40,    41,    61,    58,
      33,    35,    46,    97,   111,   112,   115,    43,    60,   103,
      91,    93,   108,   119,   114,    62,    99,   104
};
#endif

#define YYPACT_NINF (-771)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-47)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -771,     1,   849,  -771,    67,  -270,    67,  -251,  -239,  -203,
      67,  -198,  -188,  -145,    67,   614,   849,  -771,  -771,  -771,
    -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,
    -771,    87,  -117,   152,  -771,   162,    35,   168,  -771,   179,
     193,   209,  -771,   -94,  -771,  -771,  -771,  -771,  -771,  -771,
    -771,   853,   915,  -771,   753,  -771,  -771,  -771,    67,   -53,
     -55,   -43,   -35,   -26,   -21,   -16,   -14,   -12,  -771,  -771,
    -771,  -771,  -771,  -771,   -15,  -771,  -771,  -771,  -771,  -771,
    -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,
    -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,
     -11,    -2,    14,     2,     5,    15,    24,    26,  -771,  -771,
    -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,
    -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,
    -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,
    -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,
    -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,
    -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,
    -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,
    -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,
    -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,
    -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,
    -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,
    -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,
    -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,
    -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,
    -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,
     219,  -771,  -771,  -771,  -771,  -771,  -771,  -771,   144,    29,
     144,  -771,   144,  -771,   144,  -771,    34,    34,  -771,  -771,
    -771,  -771,  -771,  -771,    44,  -771,  -771,  -771,    46,    44,
      44,  -771,    46,  -771,    44,    44,    44,  -771,    54,  -771,
    -771,  -771,  -771,  -771,  -771,    18,    67,   317,  -771,  -771,
    -771,  -771,  -771,   332,   336,   337,  -165,  -165,  -165,    41,
    -165,  -165,    74,    74,    74,  -165,    74,    74,    74,  -165,
    -165,    86,    85,    93,    99,   103,   116,   120,   122,   144,
      46,    46,    46,    46,    46,    46,    46,    46,    44,    88,
      46,    46,    44,    46,    97,    97,  -771,   108,  -771,  -771,
    -771,  -771,  -771,  -771,  -771,  -771,   114,  -771,   201,    11,
     117,   129,   130,   -65,   131,   132,   133,   571,    34,   144,
     141,  -186,   136,   641,   136,   136,   136,   144,   136,   136,
     136,   156,    67,   145,   148,   147,   150,   143,  -771,   159,
     163,   170,   173,  -771,  -771,   146,  -771,   174,   175,    71,
    -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,
    -771,  -771,  -771,  -771,  -771,  -771,  -771,   176,   144,   144,
     144,   144,   165,   166,   164,   180,   136,   169,   144,   172,
     136,   144,   -56,    97,  -771,  -771,   189,   191,  -771,  -771,
      43,    43,   576,  -771,  -771,  -771,  -771,  -771,  -771,   144,
     576,    33,   576,  -771,  -771,  -771,  -771,  -771,  -771,  -771,
    -771,  -771,   194,   641,   144,  -771,  -771,   -95,    46,  -771,
    -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,   144,    46,
      46,  -771,    46,    46,    46,   199,  -771,    67,  -771,   431,
     465,    41,  -771,    74,  -153,  -153,  -771,  -771,    74,    74,
      74,  -771,  -771,   144,    43,    43,   144,   144,   144,   667,
     204,   207,   211,   212,   184,   202,   203,   205,    46,    25,
     221,   213,    46,   222,  -771,  -771,  -771,  -771,  -771,  -205,
    -205,  -771,  -771,  -771,  -771,  -771,  -771,   206,   214,  -771,
    -771,  -771,    31,   223,   224,   225,  -771,  -771,  -771,   326,
     128,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,
    -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,
    -771,  -771,  -771,    41,   683,   513,  -771,  -771,  -771,  -771,
    -771,   234,   235,   239,  -771,   255,   238,   243,  -771,  -771,
    -771,  -771,   217,   244,   240,   241,   245,   246,   253,    41,
     264,   263,   278,   267,  -771,  -771,   286,   287,   289,  -771,
    -771,  -771,  -771,  -771,  -771,   293,   296,   297,    25,  -771,
     298,  -771,  -771,   288,   292,   283,   300,    25,    25,    25,
      25,   304,  -162,   295,    25,   306,   310,    41,    41,   294,
     308,   321,   323,  -771,   327,   328,   178,   329,   345,   357,
     358,    82,  -771,  -771,  -771,  -771,   351,    41,  -771,  -771,
     576,   576,   197,  -771,  -771,   192,    41,   341,    41,    41,
      41,    41,    41,   349,  -771,    67,    41,    41,   629,  -771,
      74,    74,   144,   255,   144,   197,   346,   347,   350,   352,
    -205,   354,  -157,  -157,    41,   104,  -771,   348,  -771,   353,
    -157,    41,   356,  -771,  -771,  -771,  -771,  -205,  -205,  -771,
    -771,  -771,  -771,  -771,  -205,  -205,   373,   374,  -771,   376,
     380,  -771,    52,   381,  -771,  -771,   390,  -771,   392,   382,
     378,   144,  -771,   387,   391,   393,   119,   402,   399,   408,
     400,  -771,  -771,   411,   419,   420,   421,    25,    25,    25,
      25,   435,     3,   437,   104,   438,  -771,   440,   144,  -771,
     436,    25,   444,   423,    41,   415,   445,   455,   460,  -771,
    -771,  -771,   576,    33,   478,   192,  -160,   104,   483,   476,
     119,   119,   119,   487,   487,   487,   144,    67,  -771,  -771,
      41,   255,   255,   144,   667,  -162,   354,  -162,  -162,   495,
      25,   493,   511,  -771,   515,   517,   519,    41,  -162,   520,
     498,   512,  -771,  -771,  -771,  -771,  -771,  -771,  -771,   529,
    -771,   530,   144,   144,   521,  -771,  -771,   522,   516,   144,
     255,   144,   546,  -771,  -771,  -771,   540,  -771,   541,   544,
     545,   548,  -771,   533,   535,   536,   537,    25,  -205,   543,
      25,    25,    25,   532,  -771,   547,    25,   106,  -771,   237,
     192,   557,   559,  -771,   549,   104,   560,   562,   565,  -771,
     104,   836,   255,   255,   144,   568,   569,   573,   574,   578,
     592,    41,   596,   599,   600,   561,   601,   602,   587,   613,
    -771,  -771,  -771,   617,  -771,  -771,   615,   597,   104,   612,
     104,   104,   104,   630,   628,  -771,   632,   633,   106,   106,
     106,   106,   106,   621,  -205,   106,   106,   106,   106,   106,
     106,   635,   106,   478,   622,   623,   620,   639,  -771,   640,
     642,   104,    41,   255,   255,  -771,  -771,  -771,  -771,  -771,
     631,   634,  -771,  -771,  -771,   625,  -771,  -771,    25,  -771,
    -771,   104,   104,   643,    25,   104,   104,  -771,   645,  -771,
    -771,    41,   636,   646,   648,   637,   644,    25,   650,  -771,
    -771,   920,  -771,    41,    25,    25,   652,   655,   656,   104,
     654,  -771,   659,   664,    25,    25,    25,   665,    41,    25,
      25,   669,  -771,  -771,    25,   670,  -771,  -771,    25,  -771,
     936,   671,   672,    25,    41,  -771,  -771
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       2,     0,     4,     1,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    43,     4,     6,     7,     8,
       9,    10,    11,    12,    16,    13,    14,    15,    18,    20,
      17,     0,     0,     0,    25,     0,     0,     0,    31,     0,
       0,     0,    32,     0,    36,    37,    38,    39,    40,    41,
      42,    43,     0,     3,    43,    55,     5,    19,     0,     0,
      24,     0,     0,     0,     0,     0,     0,     0,    56,    44,
      63,    64,    66,    68,     0,    72,    74,    76,    78,    80,
      82,    83,    85,    86,    87,    88,    89,    90,    91,    93,
      94,    95,    96,    97,    99,   100,   102,   103,   105,   107,
       0,     0,     0,     0,     0,     0,     0,     0,   152,   153,
     154,   155,   136,   146,   132,   149,   137,   138,   139,   140,
     141,   156,   157,   158,   159,   147,   148,   160,   161,   162,
     163,   133,   164,   165,   142,   166,   150,   151,   167,   168,
     169,   143,   135,   134,   170,   171,   172,   173,   174,   175,
     144,   145,   176,   177,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     204,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   217,   218,   243,   244,   289,
     291,   295,   293,   302,   304,   308,   306,   312,   369,   370,
     316,   297,   310,   371,   333,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   350,   363,   362,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     334,   335,   314,   367,   299,   340,   341,   389,   391,    47,
       0,   124,   125,   126,   127,   128,   129,    48,     0,     0,
       0,    49,     0,    50,     0,    51,   253,   253,    52,   372,
     374,   373,   375,   376,     0,   331,   332,   377,     0,     0,
       0,   378,     0,   379,     0,     0,     0,   381,     0,   380,
     382,    53,   393,    54,    45,     0,     0,     0,    26,    27,
      28,    29,    30,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   387,   387,   398,     0,   403,   404,
     405,   406,   407,   399,   400,   401,     0,   410,   408,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   253,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    58,     0,
       0,     0,     0,   468,   470,     0,    70,     0,     0,     0,
      77,    79,    81,    84,    92,    98,   101,   104,   106,   112,
     114,   116,   108,   109,   118,   120,   122,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   387,   390,   392,     0,     0,   409,   411,
       0,     0,     0,   178,   179,   180,   181,   182,   183,     0,
       0,     0,     0,   245,   250,   252,   251,   246,   247,   248,
     249,   254,     0,     0,     0,   274,   275,     0,     0,   474,
     475,   476,   477,   478,   479,   480,   481,   280,     0,     0,
       0,   342,     0,     0,     0,     0,    21,     0,    23,     0,
       0,     0,    57,     0,     0,     0,   469,   471,     0,     0,
       0,    62,    61,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   386,   385,   383,   384,   388,   433,
     433,   394,   402,   412,   413,   414,   415,     0,     0,   395,
     396,   397,     0,     0,     0,     0,   130,   418,   420,   416,
       0,   422,   423,   424,   110,   442,   443,   425,   111,   444,
     131,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,     0,     0,     0,   427,   184,   429,   453,
     451,     0,     0,     0,   216,     0,     0,   273,   276,   277,
     278,   279,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    65,    60,     0,     0,     0,    71,
      73,    75,   113,   115,   117,     0,     0,     0,     0,   430,
       0,   431,   432,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   433,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   472,     0,     0,     0,     0,     0,     0,
       0,     0,   417,   419,   421,   426,     0,     0,   455,   428,
       0,     0,     0,   259,   257,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   286,     0,     0,     0,     0,    59,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     433,     0,   433,   433,     0,     0,   282,     0,   281,     0,
     433,     0,     0,   435,   434,   439,   438,   433,   433,   449,
     450,   473,   445,   446,   433,   433,     0,     0,   452,     0,
       0,   186,     0,     0,   255,   256,   271,   272,   269,     0,
       0,     0,   338,     0,     0,     0,     0,     0,     0,     0,
       0,    67,    69,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   284,     0,     0,   283,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   447,
     448,   454,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   343,   343,   343,     0,     0,    33,    34,
       0,     0,     0,     0,     0,   433,     0,   433,   433,     0,
       0,     0,     0,   285,     0,     0,     0,     0,   433,     0,
       0,     0,   437,   441,   436,   440,   185,   203,   270,   267,
     268,   264,     0,     0,     0,   348,   349,     0,     0,     0,
       0,     0,     0,   346,   347,   345,     0,    22,     0,     0,
       0,     0,   205,     0,     0,     0,     0,     0,   433,     0,
       0,     0,     0,     0,   317,     0,     0,     0,   300,     0,
       0,     0,     0,   336,     0,     0,     0,     0,     0,   344,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     265,   266,   258,   262,   263,   260,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   119,     0,     0,     0,     0,
       0,     0,     0,     0,   433,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   364,     0,
       0,     0,     0,     0,     0,   290,   292,   296,   294,   303,
       0,     0,   305,   309,   307,     0,   298,   311,     0,   301,
     261,     0,     0,     0,     0,     0,     0,   368,     0,   121,
     123,     0,     0,     0,     0,     0,     0,     0,     0,   365,
     366,     0,   287,     0,     0,     0,     0,     0,     0,     0,
       0,   288,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   330,   337,     0,     0,   313,   315,     0,   339,
       0,     0,     0,     0,     0,   329,    35
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -771,  -771,  -771,   931,  -771,    -6,  -771,  -771,  -771,  -771,
    -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,
     897,   895,  -771,  -771,   155,   446,  -300,  -771,  -771,  -771,
    -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,
    -771,  -771,  -771,  -771,  -353,  -771,  -771,  -771,  -771,  -771,
    -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,
    -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,
    -771,  -255,  -770,  -663,  -771,  -771,  -771,   271,   389,   401,
     252,  -498,  -590,  -585,   149,  -771,  -771,  -771,  -771,  -771,
    -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,
    -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,
    -771,  -771,  -771,  -771,  -771,  -771,  -631,  -501,  -148,  -771,
    -771,  -771,  -771,  -771,  -771,  -771,  -771,  -771,  -342,  -771,
    -771,  -771,  -771,  -228,   584,  -480,  -771,   586,  -263,  -771,
    -431,  -516,  -771,  -591,  -412,  -448,   153,  -523,  -771,  -771,
    -771,  -471,  -771,  -486,   372,  -317,   299,   485
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,     2,    15,    16,    32,    17,    18,   308,    19,
      60,    20,    21,    22,    23,    24,    25,    26,    27,    51,
      52,    53,    54,    55,   400,   617,   410,   259,   316,   317,
     318,   508,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   260,   556,   261,   513,   262,   514,   263,
     515,   264,   516,   265,   517,   266,   518,   267,   268,   269,
     270,   459,   271,   272,   273,   339,   274,   275,   276,   277,
     378,   379,   736,   737,   474,   901,   278,   382,   478,   384,
     706,   707,   765,   683,   763,   279,   340,   341,   343,   342,
     350,   353,   899,   280,   344,   345,   347,   346,   351,   281,
     348,   282,   352,   283,   349,   284,   285,   286,   287,   288,
     289,   290,   291,   789,   292,   293,   843,   796,   834,   294,
     295,   296,   297,   298,   299,   300,   301,   443,   444,   302,
     354,   355,   303,   557,   367,   558,   368,   369,   370,   559,
     628,   561,   562,   563,   586,   587,   630,   708,   565,   371,
     566,   567,   568,   588,   589,   590,   658,   487
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      34,     3,   406,   629,    38,   372,    33,   374,    42,   375,
     541,   376,   592,   445,   594,   829,   649,   650,   356,   560,
     560,   585,   380,   411,   412,    35,   414,   415,   416,   585,
     560,   585,   541,   632,   403,   404,   653,    36,   564,   564,
     541,   542,    62,    63,   403,   404,   403,   404,   631,   593,
     541,   542,   305,   543,   544,   545,   546,   547,   548,   541,
     542,   475,   476,   543,   544,   545,   546,   547,   548,   647,
      28,    29,    30,    37,   403,   404,   427,   511,    39,   673,
     664,   733,   648,   560,   560,   403,   404,   653,    40,   665,
      57,   739,   512,   741,   742,   743,   744,   745,   570,   669,
     903,   538,   564,   564,   756,   664,   398,   403,   404,   403,
     404,   541,   647,   767,   665,   399,   472,   647,   615,   768,
     772,   828,   830,   471,   491,   705,   773,   616,   662,   832,
     764,    41,   833,   569,   569,   541,   542,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   506,
     507,   356,   547,   548,   598,   599,   600,   601,    58,   738,
      59,   623,   624,   844,   845,   520,   521,   522,   523,    61,
     358,   359,   360,   361,   362,   530,    64,   754,   533,   766,
     766,   506,   507,   721,   613,    68,    65,   766,   453,   454,
     455,   456,   457,   458,   775,   776,   591,   569,   569,   541,
      66,   777,   778,   614,   541,   542,   900,   904,   619,   620,
     621,   597,   543,   544,   545,   546,    67,   543,   544,   545,
     546,   307,   730,   731,   306,   603,   356,   358,   359,   360,
     361,   362,   864,   534,   309,   657,   535,   536,   537,   585,
     585,   732,   310,   357,   541,   358,   359,   360,   361,   362,
     622,   311,   664,   625,   626,   627,   312,   543,   544,   545,
     546,   313,   541,   314,   732,   315,   666,   319,   332,   831,
     960,   331,   549,   550,   551,   543,   544,   545,   546,   810,
     363,   364,   365,   333,   334,   849,   850,   335,   629,   839,
     840,   841,   684,   392,   549,   550,   551,   336,   654,   655,
     393,   642,   549,   550,   551,   656,   337,   853,   338,   855,
     856,   373,   549,   550,   551,   405,   377,   405,   632,   552,
     865,   549,   550,   551,   877,   394,   381,   553,   383,   554,
     713,   714,   663,   631,   826,   890,   391,   553,   395,   554,
     555,    31,   396,   397,   726,   405,   543,   544,   545,   546,
     729,   585,   560,   902,   905,   409,   656,   663,   419,   684,
     420,   684,   684,   684,   684,   684,   915,   916,   421,   748,
     749,   827,   422,   549,   550,   551,   423,   437,   405,   442,
     405,   898,   583,   793,   794,   795,   496,   684,   714,   424,
     751,   752,   450,   425,   684,   426,   446,   549,   550,   551,
     663,   951,   447,   584,   451,   452,   460,   461,   462,   700,
     701,   702,   703,   363,   364,   365,   710,   473,   477,   495,
     497,   501,   553,   499,   554,   498,   500,   969,   970,   753,
     502,   755,   945,   946,   947,   948,   949,   611,   503,   952,
     953,   954,   955,   956,   957,   504,   959,   714,   505,   509,
     510,   519,   734,   735,   524,   525,   526,   821,   539,   529,
     540,   549,   550,   551,   531,   527,   549,   550,   551,   595,
     836,   612,   401,   402,   637,   407,   408,   769,   788,   633,
     413,   609,   634,   848,   417,   418,   635,   636,   363,   364,
     365,   610,   638,   639,   651,   640,   643,   646,   735,   676,
     684,   661,   652,   644,   663,   816,   549,   550,   551,   670,
     671,   659,   660,   366,   672,   674,   403,   404,   675,   677,
     541,   542,   678,   679,   549,   550,   551,   680,   681,   805,
     806,   807,   808,   846,   811,   682,   813,   547,   548,   685,
     851,   686,   688,   818,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   687,   689,   836,   835,
     385,   386,   690,   836,   691,   388,   389,   390,   692,   871,
     872,   693,   694,   695,   924,   698,   876,   696,   878,   403,
     404,   697,   858,   541,   542,   699,   704,   709,   711,   715,
     717,   836,   718,   836,   836,   836,   543,   544,   545,   546,
     547,   548,   712,   716,   719,   720,   722,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   436,
      43,   917,   723,   440,   836,   968,   724,   725,   728,   889,
     740,   746,   892,   893,   894,   750,   757,   758,   897,   770,
     759,   762,   760,   771,   836,   836,   774,   835,   836,   836,
     779,   780,   835,   781,   982,   782,   783,    44,    45,    46,
      47,    48,    49,    50,   786,   784,   991,   785,   787,   790,
     403,   404,   836,   791,   541,   792,   798,   797,   800,   747,
     835,  1005,   835,   835,   835,   799,   801,   543,   544,   545,
     546,   547,   548,   387,   802,   803,   804,  1016,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     822,   817,   820,   835,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   809,   909,   812,   814,
     974,   815,   913,   835,   835,   819,   978,   835,   835,   735,
     823,   428,   429,   430,   431,   432,   433,   434,   435,   988,
     824,   438,   439,   -46,   441,   825,   992,   993,   837,    43,
     936,   835,   938,   939,   940,   838,  1001,  1002,  1003,   842,
     857,  1006,  1007,   488,   489,   490,  1009,   492,   493,   494,
    1011,   859,   549,   550,   551,  1015,   860,   405,   867,   583,
     861,   847,   862,   967,   863,   866,    44,    45,    46,    47,
      48,    49,    50,   868,   869,   870,   875,   553,   879,   554,
     584,   874,   873,   975,   976,   880,   881,   979,   980,   882,
     883,   895,   463,   884,   885,   528,   886,   887,   888,   532,
     464,   891,   906,   465,   907,   910,   466,   911,   896,   908,
     912,   997,   914,   918,   919,   549,   550,   551,   920,   921,
     405,   928,   583,   922,   467,   468,   469,   470,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,   923,
     553,   925,   554,   584,   926,   927,   929,   930,   931,   602,
     479,   480,   481,   482,   483,   484,   485,   486,   932,   935,
     604,   605,   933,   606,   607,   608,    44,    45,    46,    47,
      48,    49,    50,   937,   934,   941,   942,   943,   944,   950,
     958,   963,   961,   962,   964,   965,   973,   966,   977,   971,
     981,   984,   972,   985,   983,   989,   990,   994,   986,   641,
     995,   996,   998,   645,   999,   987,   549,   550,   551,  1000,
    1004,   405,  1012,   583,  1008,  1010,  1013,    56,    69,   304,
    1014,   618,   761,   449,   448,   854,   668,   852,   596,   667,
     727,   553,     0,   554,   584,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258
};

static const yytype_int16 yycheck[] =
{
       6,     0,   319,   519,    10,   268,   276,   270,    14,   272,
       7,   274,   460,   355,   462,   785,   539,   540,     7,   450,
     451,   452,   277,   323,   324,   276,   326,   327,   328,   460,
     461,   462,     7,   519,     3,     4,     5,   276,   450,   451,
       7,     8,     7,     8,     3,     4,     3,     4,   519,   461,
       7,     8,    58,    20,    21,    22,    23,    24,    25,     7,
       8,   247,   248,    20,    21,    22,    23,    24,    25,   274,
       3,     4,     5,   276,     3,     4,   339,     6,   276,   595,
     560,   672,   287,   514,   515,     3,     4,     5,   276,   560,
       3,   676,   409,   678,   679,   680,   681,   682,   451,   585,
     870,   443,   514,   515,   695,   585,   271,     3,     4,     3,
       4,     7,   274,   703,   585,   280,   379,   274,   271,   704,
     710,   784,   785,   378,   387,   287,   711,   280,   559,   289,
     287,   276,   292,   450,   451,     7,     8,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,     3,
       4,     7,    24,    25,   249,   250,   251,   252,   275,   675,
       8,   514,   515,   794,   795,   428,   429,   430,   431,     7,
      26,    27,    28,    29,    30,   438,     8,   693,   441,   702,
     703,     3,     4,     5,   501,   279,     7,   710,   253,   254,
     255,   256,   257,   258,   717,   718,   459,   514,   515,     7,
       7,   724,   725,   503,     7,     8,   869,   870,   508,   509,
     510,   474,    20,    21,    22,    23,     7,    20,    21,    22,
      23,   276,   670,   671,   277,   488,     7,    26,    27,    28,
      29,    30,   817,   289,   277,   552,   292,   293,   294,   670,
     671,   672,   277,    24,     7,    26,    27,    28,    29,    30,
     513,   277,   732,   516,   517,   518,   277,    20,    21,    22,
      23,   277,     7,   277,   695,   277,   583,   282,   270,   785,
     933,   282,   269,   270,   271,    20,    21,    22,    23,   276,
     269,   270,   271,   269,   282,   801,   802,   282,   804,   790,
     791,   792,   609,   275,   269,   270,   271,   282,   267,   268,
     306,   529,   269,   270,   271,   274,   282,   805,   282,   807,
     808,   282,   269,   270,   271,   274,   282,   274,   804,   276,
     818,   269,   270,   271,   840,     8,   282,   294,   282,   296,
     647,   648,   560,   804,   782,   858,   282,   294,     6,   296,
     297,   274,     6,     6,   661,   274,    20,    21,    22,    23,
     667,   782,   783,   869,   870,   281,   274,   585,   272,   676,
     275,   678,   679,   680,   681,   682,   882,   883,   275,   686,
     687,   783,   273,   269,   270,   271,   273,   289,   274,   282,
     274,   867,   276,   264,   265,   266,   392,   704,   705,   273,
     690,   691,   275,   273,   711,   273,   288,   269,   270,   271,
     628,   924,   288,   297,   275,   275,   275,   275,   275,   637,
     638,   639,   640,   269,   270,   271,   644,   276,   282,   263,
     275,   278,   294,   276,   296,   277,   276,   943,   944,   692,
     271,   694,   918,   919,   920,   921,   922,     6,   275,   925,
     926,   927,   928,   929,   930,   275,   932,   764,   275,   275,
     275,   275,   260,   261,   289,   289,   292,   774,   269,   290,
     269,   269,   270,   271,   292,   285,   269,   270,   271,   275,
     787,     6,   317,   318,   290,   320,   321,   705,   741,   275,
     325,   282,   275,   800,   329,   330,   275,   275,   269,   270,
     271,   497,   290,   290,   288,   290,   275,   275,   261,   282,
     817,   276,   288,   290,   732,   768,   269,   270,   271,   275,
     275,   288,   288,   294,   275,   277,     3,     4,   275,   275,
       7,     8,   282,   282,   269,   270,   271,   282,   282,   757,
     758,   759,   760,   796,   762,   282,   764,    24,    25,   275,
     803,   278,   275,   771,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,   278,   271,   875,   787,
     289,   290,   275,   880,   275,   294,   295,   296,   275,   832,
     833,   275,   275,   275,   891,   292,   839,   289,   841,     3,
       4,   289,   810,     7,     8,   285,   282,   292,   282,   295,
     269,   908,   269,   910,   911,   912,    20,    21,    22,    23,
      24,    25,   292,   295,   277,   277,   277,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,   348,
       6,   884,   277,   352,   941,   942,   269,   269,   277,   857,
     289,   282,   860,   861,   862,     6,   290,   290,   866,   291,
     290,   287,   290,   290,   961,   962,   290,   875,   965,   966,
     277,   277,   880,   277,   971,   275,   275,    43,    44,    45,
      46,    47,    48,    49,   282,   275,   983,   275,   290,   282,
       3,     4,   989,   282,     7,   282,   277,   275,   278,   685,
     908,   998,   910,   911,   912,   277,   275,    20,    21,    22,
      23,    24,    25,   292,   275,   275,   275,  1014,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
     295,   275,   289,   941,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,   291,   875,   291,   291,
     958,   291,   880,   961,   962,   291,   964,   965,   966,   261,
     295,   340,   341,   342,   343,   344,   345,   346,   347,   977,
     295,   350,   351,     0,   353,   295,   984,   985,   275,     6,
     908,   989,   910,   911,   912,   289,   994,   995,   996,   282,
     275,   999,  1000,   384,   385,   386,  1004,   388,   389,   390,
    1008,   288,   269,   270,   271,  1013,   275,   274,   290,   276,
     275,   797,   275,   941,   275,   275,    43,    44,    45,    46,
      47,    48,    49,   291,   275,   275,   290,   294,   262,   296,
     297,   289,   291,   961,   962,   275,   275,   965,   966,   275,
     275,   289,   251,   275,   291,   436,   291,   291,   291,   440,
     259,   288,   275,   262,   275,   275,   265,   275,   291,   290,
     275,   989,     6,   275,   275,   269,   270,   271,   275,   275,
     274,   290,   276,   275,   283,   284,   285,   286,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,   277,
     294,   275,   296,   297,   275,   275,   275,   275,   291,   478,
     239,   240,   241,   242,   243,   244,   245,   246,   275,   292,
     489,   490,   275,   492,   493,   494,    43,    44,    45,    46,
      47,    48,    49,   291,   289,   275,   278,   275,   275,   288,
     275,   291,   290,   290,   275,   275,   291,   275,   275,   288,
     275,   275,   288,   275,   288,   275,     6,   275,   291,   528,
     275,   275,   278,   532,   275,   291,   269,   270,   271,   275,
     275,   274,     6,   276,   275,   275,   275,    16,    51,    54,
     278,   505,   700,   369,   368,   806,   584,   804,   473,   276,
     661,   294,    -1,   296,   297,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,   299,   300,     0,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,   301,   302,   304,   305,   307,
     309,   310,   311,   312,   313,   314,   315,   316,     3,     4,
       5,   274,   303,   276,   303,   276,   276,   276,   303,   276,
     276,   276,   303,     6,    43,    44,    45,    46,    47,    48,
      49,   317,   318,   319,   320,   321,   301,     3,   275,     8,
     308,     7,     7,     8,     8,     7,     7,     7,   279,   318,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   325,
     341,   343,   345,   347,   349,   351,   353,   355,   356,   357,
     358,   360,   361,   362,   364,   365,   366,   367,   374,   383,
     391,   397,   399,   401,   403,   404,   405,   406,   407,   408,
     409,   410,   412,   413,   417,   418,   419,   420,   421,   422,
     423,   424,   427,   430,   319,   303,   277,   276,   306,   277,
     277,   277,   277,   277,   277,   277,   326,   327,   328,   282,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   282,   270,   269,   282,   282,   282,   282,   282,   363,
     384,   385,   387,   386,   392,   393,   395,   394,   398,   402,
     388,   396,   400,   389,   428,   429,     7,    24,    26,    27,
      28,    29,    30,   269,   270,   271,   294,   432,   434,   435,
     436,   447,   436,   282,   436,   436,   436,   282,   368,   369,
     369,   282,   375,   282,   377,   375,   375,   377,   375,   375,
     375,   282,   275,   303,     8,     6,     6,     6,   271,   280,
     322,   322,   322,     3,     4,   274,   453,   322,   322,   281,
     324,   324,   324,   322,   324,   324,   324,   322,   322,   272,
     275,   275,   273,   273,   273,   273,   273,   436,   377,   377,
     377,   377,   377,   377,   377,   377,   375,   289,   377,   377,
     375,   377,   282,   425,   426,   426,   288,   288,   435,   432,
     275,   275,   275,   253,   254,   255,   256,   257,   258,   359,
     275,   275,   275,   251,   259,   262,   265,   283,   284,   285,
     286,   369,   436,   276,   372,   247,   248,   282,   376,   239,
     240,   241,   242,   243,   244,   245,   246,   455,   376,   376,
     376,   436,   376,   376,   376,   263,   303,   275,   277,   276,
     276,   278,   271,   275,   275,   275,     3,     4,   329,   275,
     275,     6,   453,   344,   346,   348,   350,   352,   354,   275,
     436,   436,   436,   436,   289,   289,   292,   285,   376,   290,
     436,   292,   376,   436,   289,   292,   293,   294,   426,   269,
     269,     7,     8,    20,    21,    22,    23,    24,    25,   269,
     270,   271,   276,   294,   296,   297,   342,   431,   433,   437,
     438,   439,   440,   441,   442,   446,   448,   449,   450,   453,
     342,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,   276,   297,   438,   442,   443,   451,   452,
     453,   436,   443,   442,   443,   275,   455,   436,   249,   250,
     251,   252,   377,   436,   377,   377,   377,   377,   377,   282,
     303,     6,     6,   453,   324,   271,   280,   323,   323,   324,
     324,   324,   436,   342,   342,   436,   436,   436,   438,   439,
     444,   449,   451,   275,   275,   275,   275,   290,   290,   290,
     290,   377,   431,   275,   290,   377,   275,   274,   287,   445,
     445,   288,   288,     5,   267,   268,   274,   453,   454,   288,
     288,   276,   438,   431,   433,   449,   453,   276,   452,   451,
     275,   275,   275,   439,   277,   275,   282,   275,   282,   282,
     282,   282,   282,   381,   453,   275,   278,   278,   275,   271,
     275,   275,   275,   275,   275,   275,   289,   289,   292,   285,
     431,   431,   431,   431,   282,   287,   378,   379,   445,   292,
     431,   282,   292,   453,   453,   295,   295,   269,   269,   277,
     277,     5,   277,   277,   269,   269,   453,   454,   277,   453,
     443,   443,   438,   441,   260,   261,   370,   371,   439,   381,
     289,   381,   381,   381,   381,   381,   282,   303,   453,   453,
       6,   324,   324,   436,   439,   436,   441,   290,   290,   290,
     290,   378,   287,   382,   287,   380,   445,   380,   381,   431,
     291,   290,   380,   381,   290,   445,   445,   445,   445,   277,
     277,   277,   275,   275,   275,   275,   282,   290,   436,   411,
     282,   282,   282,   264,   265,   266,   415,   275,   277,   277,
     278,   275,   275,   275,   275,   431,   431,   431,   431,   291,
     276,   431,   291,   431,   291,   291,   436,   275,   431,   291,
     289,   453,   295,   295,   295,   295,   443,   442,   371,   370,
     371,   439,   289,   292,   416,   431,   453,   275,   289,   415,
     415,   415,   282,   414,   414,   414,   436,   303,   453,   439,
     439,   436,   444,   379,   382,   379,   379,   275,   431,   288,
     275,   275,   275,   275,   381,   379,   275,   290,   291,   275,
     275,   436,   436,   291,   289,   290,   436,   439,   436,   262,
     275,   275,   275,   275,   275,   291,   291,   291,   291,   431,
     445,   288,   431,   431,   431,   289,   291,   431,   451,   390,
     371,   373,   439,   370,   371,   439,   275,   275,   290,   416,
     275,   275,   275,   416,     6,   439,   439,   436,   275,   275,
     275,   275,   275,   277,   453,   275,   275,   275,   290,   275,
     275,   291,   275,   275,   289,   292,   416,   291,   416,   416,
     416,   275,   278,   275,   275,   451,   451,   451,   451,   451,
     288,   445,   451,   451,   451,   451,   451,   451,   275,   451,
     371,   290,   290,   291,   275,   275,   275,   416,   453,   439,
     439,   288,   288,   291,   431,   416,   416,   275,   431,   416,
     416,   275,   453,   288,   275,   275,   291,   291,   431,   275,
       6,   453,   431,   431,   275,   275,   275,   416,   278,   275,
     275,   431,   431,   431,   275,   453,   431,   431,   275,   431,
     275,   431,     6,   275,   278,   431,   453
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int16 yyr1[] =
{
       0,   298,   300,   299,   301,   301,   302,   302,   302,   302,
     302,   302,   302,   302,   302,   302,   302,   303,   303,   303,
     303,   304,   305,   306,   306,   308,   307,   309,   310,   310,
     311,   312,   313,   314,   315,   316,   317,   317,   317,   317,
     317,   317,   317,   318,   318,   319,   319,   320,   320,   320,
     320,   320,   320,   320,   320,   320,   321,   322,   322,   323,
     323,   324,   324,   325,   326,   325,   327,   325,   328,   325,
     329,   325,   330,   325,   331,   325,   332,   325,   333,   325,
     334,   325,   325,   335,   325,   325,   325,   325,   325,   325,
     325,   336,   325,   325,   325,   325,   325,   337,   325,   325,
     338,   325,   325,   339,   325,   340,   325,   325,   341,   341,
     342,   342,   344,   343,   346,   345,   348,   347,   350,   349,
     352,   351,   354,   353,   355,   355,   355,   355,   355,   355,
     355,   355,   356,   356,   356,   356,   356,   356,   356,   356,
     356,   356,   356,   356,   356,   356,   357,   357,   357,   357,
     357,   357,   358,   358,   358,   358,   358,   358,   358,   358,
     358,   358,   358,   358,   358,   358,   358,   358,   358,   358,
     358,   358,   358,   358,   358,   358,   358,   358,   359,   359,
     359,   359,   359,   359,   360,   360,   360,   361,   361,   361,
     361,   361,   361,   361,   361,   361,   361,   361,   361,   361,
     361,   361,   361,   362,   363,   362,   364,   364,   364,   364,
     364,   364,   364,   364,   364,   364,   365,   366,   366,   367,
     367,   367,   367,   367,   367,   367,   367,   367,   367,   367,
     367,   367,   367,   367,   367,   367,   367,   367,   367,   367,
     367,   367,   367,   367,   367,   368,   368,   368,   368,   368,
     368,   368,   368,   369,   369,   370,   371,   372,   373,   374,
     374,   374,   374,   374,   374,   374,   374,   374,   374,   374,
     374,   374,   374,   374,   375,   375,   376,   376,   376,   376,
     377,   378,   379,   379,   380,   380,   381,   382,   382,   384,
     383,   385,   383,   386,   383,   387,   383,   388,   383,   389,
     390,   383,   392,   391,   393,   391,   394,   391,   395,   391,
     396,   391,   398,   397,   400,   399,   402,   401,   403,   403,
     403,   403,   403,   403,   403,   403,   403,   403,   403,   404,
     405,   406,   406,   407,   408,   409,   410,   410,   411,   410,
     412,   412,   413,   414,   414,   415,   415,   415,   416,   416,
     417,   418,   418,   418,   418,   418,   418,   418,   418,   418,
     418,   418,   418,   419,   420,   420,   420,   421,   422,   423,
     423,   423,   424,   424,   424,   424,   424,   424,   424,   424,
     424,   424,   424,   425,   425,   425,   425,   426,   426,   428,
     427,   429,   427,   430,   431,   431,   431,   431,   432,   432,
     432,   432,   433,   434,   434,   434,   434,   434,   435,   435,
     436,   436,   437,   437,   437,   437,   438,   438,   439,   439,
     440,   440,   441,   441,   442,   442,   442,   443,   443,   443,
     444,   444,   444,   445,   445,   445,   446,   446,   447,   447,
     448,   448,   449,   449,   450,   450,   450,   450,   450,   450,
     450,   451,   451,   451,   451,   451,   452,   452,   452,   452,
     452,   452,   452,   452,   452,   452,   452,   452,   453,   453,
     453,   453,   454,   454,   455,   455,   455,   455,   455,   455,
     455,   455
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     3,     0,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       1,     6,    11,     3,     0,     0,     4,     4,     4,     4,
       4,     2,     2,    10,    10,    23,     1,     1,     1,     1,
       1,     1,     1,     0,     2,     2,     1,     2,     2,     2,
       2,     2,     2,     2,     2,     1,     2,     2,     1,     2,
       1,     2,     2,     1,     0,     5,     0,     7,     0,     7,
       0,     5,     0,     5,     0,     5,     0,     3,     0,     3,
       0,     3,     1,     0,     3,     1,     1,     1,     1,     1,
       1,     0,     3,     1,     1,     1,     1,     0,     3,     1,
       0,     3,     1,     0,     3,     0,     3,     1,     3,     3,
       1,     1,     0,     5,     0,     5,     0,     5,     0,    11,
       0,    13,     0,    13,     1,     1,     1,     1,     1,     1,
       4,     4,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     4,     8,     6,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     8,     0,     9,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     4,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     2,     2,     2,     2,
       2,     2,     2,     0,     2,     1,     1,     3,     1,     5,
      10,    12,    10,    10,     8,    10,    10,     8,     8,     6,
       8,     6,     6,     4,     2,     2,     2,     2,     2,     2,
       2,     1,     1,     2,     1,     2,     1,     8,     9,     0,
      12,     0,    12,     0,    12,     0,    12,     0,    12,     0,
       0,    12,     0,    12,     0,    12,     0,    12,     0,    12,
       0,    12,     0,    17,     0,    17,     0,     9,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,    20,
      16,     1,     1,     1,     1,     1,     9,    16,     0,    17,
       1,     1,     3,     0,     2,     2,     2,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,    11,    13,    13,     1,    12,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     2,     2,     2,     0,     2,     0,
       3,     0,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       1,     2,     1,     1,     1,     1,     1,     2,     1,     2,
       1,     2,     1,     1,     1,     1,     2,     1,     2,     1,
       1,     1,     1,     0,     2,     2,     5,     5,     5,     5,
       5,     5,     1,     1,     1,     3,     3,     4,     4,     3,
       3,     1,     3,     1,     4,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       1,     2,     1,     2,     1,     1,     1,     1,     1,     1,
       1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
# ifndef YY_LOCATION_PRINT
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yysymbol_kind_t yytoken;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  int yyn = yypact[+*yyctx->yyssp];
  if (!yypact_value_is_default (yyn))
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  In other words, skip the first -YYN actions for
         this state because they are default actions.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;
      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yyx;
      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
        if (yycheck[yyx + yyn] == yyx && yyx != YYSYMBOL_YYerror
            && !yytable_value_is_error (yytable[yyx + yyn]))
          {
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = YY_CAST (yysymbol_kind_t, yyx);
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* $@1: %empty  */
#line 644 "../src/freedreno/ir3/ir3_parser.y"
                   { new_shader(); }
#line 2898 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 17: /* const_val: T_FLOAT  */
#line 661 "../src/freedreno/ir3/ir3_parser.y"
                             { (yyval.unum) = fui((yyvsp[0].flt)); }
#line 2904 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 18: /* const_val: T_INT  */
#line 662 "../src/freedreno/ir3/ir3_parser.y"
                             { (yyval.unum) = (yyvsp[0].num);      }
#line 2910 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 19: /* const_val: '-' T_INT  */
#line 663 "../src/freedreno/ir3/ir3_parser.y"
                             { (yyval.unum) = -(yyvsp[0].num);     }
#line 2916 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 20: /* const_val: T_HEX  */
#line 664 "../src/freedreno/ir3/ir3_parser.y"
                             { (yyval.unum) = (yyvsp[0].unum);      }
#line 2922 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 21: /* localsize_header: T_A_LOCALSIZE const_val ',' const_val ',' const_val  */
#line 666 "../src/freedreno/ir3/ir3_parser.y"
                                                                       {
                       variant->local_size[0] = (yyvsp[-4].unum);
                       variant->local_size[1] = (yyvsp[-2].unum);
                       variant->local_size[2] = (yyvsp[0].unum);
}
#line 2932 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 22: /* const_header: T_A_CONST '(' T_CONSTANT ')' const_val ',' const_val ',' const_val ',' const_val  */
#line 672 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                    {
                       add_const((yyvsp[-8].num), (yyvsp[-6].unum), (yyvsp[-4].unum), (yyvsp[-2].unum), (yyvsp[0].unum));
}
#line 2940 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 23: /* buf_header_addr_reg: '(' T_CONSTANT ')'  */
#line 677 "../src/freedreno/ir3/ir3_parser.y"
                                      {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;

                       info->buf_addr_regs[info->num_bufs - 1] = reg;
                       /* reserve space in immediates for the actual value to be plugged in later: */
                       add_const((yyvsp[-1].num), 0, 0, 0, 0);
}
#line 2953 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 25: /* $@2: %empty  */
#line 687 "../src/freedreno/ir3/ir3_parser.y"
                                     {
                       int idx = info->num_bufs++;
                       assert(idx < MAX_BUFS);
                       info->buf_sizes[idx] = (yyvsp[0].unum);
}
#line 2963 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 27: /* invocationid_header: T_A_INVOCATIONID '(' T_REGISTER ')'  */
#line 693 "../src/freedreno/ir3/ir3_parser.y"
                                                         {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;
                       add_sysval(reg, 0x7, SYSTEM_VALUE_LOCAL_INVOCATION_ID);
}
#line 2973 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 28: /* wgid_header: T_A_WGID '(' T_REGISTER ')'  */
#line 699 "../src/freedreno/ir3/ir3_parser.y"
                                               {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;
                       assert(variant->shader->compiler->gen >= 5);
                       assert(reg >= regid(48, 0)); /* must be a high reg */
                       add_sysval(reg, 0x7, SYSTEM_VALUE_WORKGROUP_ID);
}
#line 2985 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 29: /* wgid_header: T_A_WGID '(' T_CONSTANT ')'  */
#line 706 "../src/freedreno/ir3/ir3_parser.y"
                                               {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;
                       assert(variant->shader->compiler->gen < 5);
                       info->wgid = reg;
}
#line 2996 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 30: /* numwg_header: T_A_NUMWG '(' T_CONSTANT ')'  */
#line 713 "../src/freedreno/ir3/ir3_parser.y"
                                                {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;
                       info->numwg = reg;
                       /* reserve space in immediates for the actual value to be plugged in later: */
                       if (variant->shader->compiler->gen >= 5)
                          add_const((yyvsp[-1].num), 0, 0, 0, 0);
}
#line 3009 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 31: /* branchstack_header: T_A_BRANCHSTACK const_val  */
#line 722 "../src/freedreno/ir3/ir3_parser.y"
                                              { variant->branchstack = (yyvsp[0].unum); }
#line 3015 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 32: /* pvtmem_header: T_A_PVTMEM const_val  */
#line 724 "../src/freedreno/ir3/ir3_parser.y"
                                    { variant->pvtmem_size = (yyvsp[0].unum); }
#line 3021 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 33: /* in_header: T_A_IN '(' T_REGISTER ')' T_IDENTIFIER '(' T_IDENTIFIER '=' integer ')'  */
#line 727 "../src/freedreno/ir3/ir3_parser.y"
                                                                                           { }
#line 3027 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 34: /* out_header: T_A_OUT '(' T_REGISTER ')' T_IDENTIFIER '(' T_IDENTIFIER '=' integer ')'  */
#line 729 "../src/freedreno/ir3/ir3_parser.y"
                                                                                            { }
#line 3033 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 35: /* tex_header: T_A_TEX '(' T_REGISTER ')' T_IDENTIFIER '=' integer ',' T_IDENTIFIER '=' integer ',' T_IDENTIFIER '=' integer ',' T_IDENTIFIER '=' integer ',' T_IDENTIFIER '=' integer  */
#line 736 "../src/freedreno/ir3/ir3_parser.y"
                                                              { }
#line 3039 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 36: /* iflag: T_SY  */
#line 738 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_SY; }
#line 3045 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 37: /* iflag: T_SS  */
#line 739 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_SS; }
#line 3051 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 38: /* iflag: T_JP  */
#line 740 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_JP; }
#line 3057 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 39: /* iflag: T_SAT  */
#line 741 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_SAT; }
#line 3063 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 40: /* iflag: T_RPT  */
#line 742 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.repeat = (yyvsp[0].num); }
#line 3069 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 41: /* iflag: T_UL  */
#line 743 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_UL; }
#line 3075 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 42: /* iflag: T_NOP  */
#line 744 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.nop = (yyvsp[0].tok); }
#line 3081 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 52: /* instr: iflags cat5_instr  */
#line 757 "../src/freedreno/ir3/ir3_parser.y"
                                     { fixup_cat5_s2en(); }
#line 3087 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 56: /* label: T_IDENTIFIER ':'  */
#line 762 "../src/freedreno/ir3/ir3_parser.y"
                                    { new_label((yyvsp[-1].str)); }
#line 3093 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 57: /* cat0_src1: '!' T_P0  */
#line 764 "../src/freedreno/ir3/ir3_parser.y"
                                   { instr->cat0.inv1 = true; instr->cat0.comp1 = (yyvsp[0].num) >> 1; }
#line 3099 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 58: /* cat0_src1: T_P0  */
#line 765 "../src/freedreno/ir3/ir3_parser.y"
                                   { instr->cat0.comp1 = (yyvsp[0].num) >> 1; }
#line 3105 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 59: /* cat0_src2: '!' T_P0  */
#line 767 "../src/freedreno/ir3/ir3_parser.y"
                                   { instr->cat0.inv2 = true; instr->cat0.comp2 = (yyvsp[0].num) >> 1; }
#line 3111 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 60: /* cat0_src2: T_P0  */
#line 768 "../src/freedreno/ir3/ir3_parser.y"
                                   { instr->cat0.comp2 = (yyvsp[0].num) >> 1; }
#line 3117 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 61: /* cat0_immed: '#' integer  */
#line 770 "../src/freedreno/ir3/ir3_parser.y"
                                   { instr->cat0.immed = (yyvsp[0].num); }
#line 3123 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 62: /* cat0_immed: '#' T_IDENTIFIER  */
#line 771 "../src/freedreno/ir3/ir3_parser.y"
                                    { ralloc_steal(instr, (void *)(yyvsp[0].str)); instr->cat0.target_label = (yyvsp[0].str); }
#line 3129 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 63: /* cat0_instr: T_OP_NOP  */
#line 773 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_NOP); }
#line 3135 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 64: /* $@3: %empty  */
#line 774 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_B)->cat0.brtype = BRANCH_PLAIN; }
#line 3141 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 66: /* $@4: %empty  */
#line 775 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_B)->cat0.brtype = BRANCH_OR;    }
#line 3147 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 68: /* $@5: %empty  */
#line 776 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_B)->cat0.brtype = BRANCH_AND;    }
#line 3153 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 70: /* $@6: %empty  */
#line 777 "../src/freedreno/ir3/ir3_parser.y"
                                         { new_instr(OPC_B)->cat0.brtype = BRANCH_CONST; instr->cat0.idx = (yyvsp[0].num); }
#line 3159 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 72: /* $@7: %empty  */
#line 778 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_B)->cat0.brtype = BRANCH_ANY; }
#line 3165 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 74: /* $@8: %empty  */
#line 779 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_B)->cat0.brtype = BRANCH_ALL; }
#line 3171 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 76: /* $@9: %empty  */
#line 780 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_B)->cat0.brtype = BRANCH_X; }
#line 3177 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 78: /* $@10: %empty  */
#line 781 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_JUMP); }
#line 3183 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 80: /* $@11: %empty  */
#line 782 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_CALL); }
#line 3189 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 82: /* cat0_instr: T_OP_RET  */
#line 783 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_RET); }
#line 3195 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 83: /* $@12: %empty  */
#line 784 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_KILL); }
#line 3201 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 85: /* cat0_instr: T_OP_END  */
#line 785 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_END); }
#line 3207 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 86: /* cat0_instr: T_OP_EMIT  */
#line 786 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_EMIT); }
#line 3213 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 87: /* cat0_instr: T_OP_CUT  */
#line 787 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_CUT); }
#line 3219 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 88: /* cat0_instr: T_OP_CHMASK  */
#line 788 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_CHMASK); }
#line 3225 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 89: /* cat0_instr: T_OP_CHSH  */
#line 789 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_CHSH); }
#line 3231 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 90: /* cat0_instr: T_OP_FLOW_REV  */
#line 790 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_FLOW_REV); }
#line 3237 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 91: /* $@13: %empty  */
#line 791 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_BKT); }
#line 3243 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 93: /* cat0_instr: T_OP_STKS  */
#line 792 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_STKS); }
#line 3249 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 94: /* cat0_instr: T_OP_STKR  */
#line 793 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_STKR); }
#line 3255 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 95: /* cat0_instr: T_OP_XSET  */
#line 794 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_XSET); }
#line 3261 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 96: /* cat0_instr: T_OP_XCLR  */
#line 795 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_XCLR); }
#line 3267 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 97: /* $@14: %empty  */
#line 796 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_GETONE); }
#line 3273 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 99: /* cat0_instr: T_OP_DBG  */
#line 797 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_DBG); }
#line 3279 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 100: /* $@15: %empty  */
#line 798 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_SHPS); }
#line 3285 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 102: /* cat0_instr: T_OP_SHPE  */
#line 799 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_SHPE); }
#line 3291 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 103: /* $@16: %empty  */
#line 800 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_PREDT); }
#line 3297 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 105: /* $@17: %empty  */
#line 801 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_PREDF); }
#line 3303 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 107: /* cat0_instr: T_OP_PREDE  */
#line 802 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_PREDE); }
#line 3309 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 108: /* cat1_opc: T_OP_MOV '.' T_CAT1_TYPE_TYPE  */
#line 804 "../src/freedreno/ir3/ir3_parser.y"
                                                 {
                       parse_type_type(new_instr(OPC_MOV), (yyvsp[0].str));
}
#line 3317 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 109: /* cat1_opc: T_OP_COV '.' T_CAT1_TYPE_TYPE  */
#line 807 "../src/freedreno/ir3/ir3_parser.y"
                                                 {
                       parse_type_type(new_instr(OPC_MOV), (yyvsp[0].str));
}
#line 3325 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 112: /* $@18: %empty  */
#line 814 "../src/freedreno/ir3/ir3_parser.y"
                                       {
                       new_instr(OPC_MOVMSK);
                       instr->cat1.src_type = TYPE_U32;
                       instr->cat1.dst_type = TYPE_U32;
                       instr->repeat = (yyvsp[0].num) - 1;
                   }
#line 3336 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 113: /* cat1_movmsk: T_OP_MOVMSK '.' T_W $@18 dst_reg  */
#line 819 "../src/freedreno/ir3/ir3_parser.y"
                             {
                       instr->dsts[0]->wrmask = (1 << (yyvsp[-2].num)) - 1;
                   }
#line 3344 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 114: /* $@19: %empty  */
#line 823 "../src/freedreno/ir3/ir3_parser.y"
                                       {
                       new_instr(OPC_MOV);
                       instr->cat1.src_type = TYPE_U16;
                       instr->cat1.dst_type = TYPE_U16;
                       new_dst((61 << 3) + 2, IR3_REG_HALF);
                   }
#line 3355 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 116: /* $@20: %empty  */
#line 830 "../src/freedreno/ir3/ir3_parser.y"
                                      {
                       new_instr(OPC_MOV);
                       instr->cat1.src_type = TYPE_S16;
                       instr->cat1.dst_type = TYPE_S16;
                       new_dst((61 << 3), IR3_REG_HALF);
                   }
#line 3366 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 118: /* $@21: %empty  */
#line 837 "../src/freedreno/ir3/ir3_parser.y"
                                                 { parse_type_type(new_instr(OPC_SWZ), (yyvsp[0].str)); }
#line 3372 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 120: /* $@22: %empty  */
#line 839 "../src/freedreno/ir3/ir3_parser.y"
                                                 { parse_type_type(new_instr(OPC_GAT), (yyvsp[0].str)); }
#line 3378 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 122: /* $@23: %empty  */
#line 841 "../src/freedreno/ir3/ir3_parser.y"
                                                 { parse_type_type(new_instr(OPC_SCT), (yyvsp[0].str)); }
#line 3384 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 132: /* cat2_opc_1src: T_OP_ABSNEG_F  */
#line 853 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ABSNEG_F); }
#line 3390 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 133: /* cat2_opc_1src: T_OP_ABSNEG_S  */
#line 854 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ABSNEG_S); }
#line 3396 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 134: /* cat2_opc_1src: T_OP_CLZ_B  */
#line 855 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CLZ_B); }
#line 3402 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 135: /* cat2_opc_1src: T_OP_CLZ_S  */
#line 856 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CLZ_S); }
#line 3408 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 136: /* cat2_opc_1src: T_OP_SIGN_F  */
#line 857 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SIGN_F); }
#line 3414 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 137: /* cat2_opc_1src: T_OP_FLOOR_F  */
#line 858 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_FLOOR_F); }
#line 3420 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 138: /* cat2_opc_1src: T_OP_CEIL_F  */
#line 859 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CEIL_F); }
#line 3426 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 139: /* cat2_opc_1src: T_OP_RNDNE_F  */
#line 860 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RNDNE_F); }
#line 3432 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 140: /* cat2_opc_1src: T_OP_RNDAZ_F  */
#line 861 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RNDAZ_F); }
#line 3438 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 141: /* cat2_opc_1src: T_OP_TRUNC_F  */
#line 862 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_TRUNC_F); }
#line 3444 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 142: /* cat2_opc_1src: T_OP_NOT_B  */
#line 863 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_NOT_B); }
#line 3450 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 143: /* cat2_opc_1src: T_OP_BFREV_B  */
#line 864 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_BFREV_B); }
#line 3456 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 144: /* cat2_opc_1src: T_OP_SETRM  */
#line 865 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SETRM); }
#line 3462 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 145: /* cat2_opc_1src: T_OP_CBITS_B  */
#line 866 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CBITS_B); }
#line 3468 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 146: /* cat2_opc_2src_cnd: T_OP_CMPS_F  */
#line 868 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPS_F); }
#line 3474 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 147: /* cat2_opc_2src_cnd: T_OP_CMPS_U  */
#line 869 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPS_U); }
#line 3480 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 148: /* cat2_opc_2src_cnd: T_OP_CMPS_S  */
#line 870 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPS_S); }
#line 3486 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 149: /* cat2_opc_2src_cnd: T_OP_CMPV_F  */
#line 871 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPV_F); }
#line 3492 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 150: /* cat2_opc_2src_cnd: T_OP_CMPV_U  */
#line 872 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPV_U); }
#line 3498 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 151: /* cat2_opc_2src_cnd: T_OP_CMPV_S  */
#line 873 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPV_S); }
#line 3504 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 152: /* cat2_opc_2src: T_OP_ADD_F  */
#line 875 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ADD_F); }
#line 3510 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 153: /* cat2_opc_2src: T_OP_MIN_F  */
#line 876 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MIN_F); }
#line 3516 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 154: /* cat2_opc_2src: T_OP_MAX_F  */
#line 877 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAX_F); }
#line 3522 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 155: /* cat2_opc_2src: T_OP_MUL_F  */
#line 878 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MUL_F); }
#line 3528 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 156: /* cat2_opc_2src: T_OP_ADD_U  */
#line 879 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ADD_U); }
#line 3534 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 157: /* cat2_opc_2src: T_OP_ADD_S  */
#line 880 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ADD_S); }
#line 3540 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 158: /* cat2_opc_2src: T_OP_SUB_U  */
#line 881 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SUB_U); }
#line 3546 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 159: /* cat2_opc_2src: T_OP_SUB_S  */
#line 882 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SUB_S); }
#line 3552 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 160: /* cat2_opc_2src: T_OP_MIN_U  */
#line 883 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MIN_U); }
#line 3558 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 161: /* cat2_opc_2src: T_OP_MIN_S  */
#line 884 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MIN_S); }
#line 3564 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 162: /* cat2_opc_2src: T_OP_MAX_U  */
#line 885 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAX_U); }
#line 3570 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 163: /* cat2_opc_2src: T_OP_MAX_S  */
#line 886 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAX_S); }
#line 3576 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 164: /* cat2_opc_2src: T_OP_AND_B  */
#line 887 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_AND_B); }
#line 3582 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 165: /* cat2_opc_2src: T_OP_OR_B  */
#line 888 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_OR_B); }
#line 3588 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 166: /* cat2_opc_2src: T_OP_XOR_B  */
#line 889 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_XOR_B); }
#line 3594 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 167: /* cat2_opc_2src: T_OP_MUL_U24  */
#line 890 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MUL_U24); }
#line 3600 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 168: /* cat2_opc_2src: T_OP_MUL_S24  */
#line 891 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MUL_S24); }
#line 3606 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 169: /* cat2_opc_2src: T_OP_MULL_U  */
#line 892 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MULL_U); }
#line 3612 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 170: /* cat2_opc_2src: T_OP_SHL_B  */
#line 893 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHL_B); }
#line 3618 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 171: /* cat2_opc_2src: T_OP_SHR_B  */
#line 894 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHR_B); }
#line 3624 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 172: /* cat2_opc_2src: T_OP_ASHR_B  */
#line 895 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ASHR_B); }
#line 3630 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 173: /* cat2_opc_2src: T_OP_BARY_F  */
#line 896 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_BARY_F); }
#line 3636 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 174: /* cat2_opc_2src: T_OP_MGEN_B  */
#line 897 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MGEN_B); }
#line 3642 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 175: /* cat2_opc_2src: T_OP_GETBIT_B  */
#line 898 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETBIT_B); }
#line 3648 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 176: /* cat2_opc_2src: T_OP_SHB  */
#line 899 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHB); }
#line 3654 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 177: /* cat2_opc_2src: T_OP_MSAD  */
#line 900 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MSAD); }
#line 3660 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 178: /* cond: T_LT  */
#line 902 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_LT; }
#line 3666 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 179: /* cond: T_LE  */
#line 903 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_LE; }
#line 3672 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 180: /* cond: T_GT  */
#line 904 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_GT; }
#line 3678 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 181: /* cond: T_GE  */
#line 905 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_GE; }
#line 3684 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 182: /* cond: T_EQ  */
#line 906 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_EQ; }
#line 3690 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 183: /* cond: T_NE  */
#line 907 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_NE; }
#line 3696 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 187: /* cat3_opc: T_OP_MAD_U16  */
#line 913 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_U16); }
#line 3702 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 188: /* cat3_opc: T_OP_MADSH_U16  */
#line 914 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MADSH_U16); }
#line 3708 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 189: /* cat3_opc: T_OP_MAD_S16  */
#line 915 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_S16); }
#line 3714 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 190: /* cat3_opc: T_OP_MADSH_M16  */
#line 916 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MADSH_M16); }
#line 3720 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 191: /* cat3_opc: T_OP_MAD_U24  */
#line 917 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_U24); }
#line 3726 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 192: /* cat3_opc: T_OP_MAD_S24  */
#line 918 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_S24); }
#line 3732 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 193: /* cat3_opc: T_OP_MAD_F16  */
#line 919 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_F16); }
#line 3738 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 194: /* cat3_opc: T_OP_MAD_F32  */
#line 920 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_F32); }
#line 3744 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 195: /* cat3_opc: T_OP_SEL_B16  */
#line 921 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_B16); }
#line 3750 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 196: /* cat3_opc: T_OP_SEL_B32  */
#line 922 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_B32); }
#line 3756 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 197: /* cat3_opc: T_OP_SEL_S16  */
#line 923 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_S16); }
#line 3762 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 198: /* cat3_opc: T_OP_SEL_S32  */
#line 924 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_S32); }
#line 3768 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 199: /* cat3_opc: T_OP_SEL_F16  */
#line 925 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_F16); }
#line 3774 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 200: /* cat3_opc: T_OP_SEL_F32  */
#line 926 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_F32); }
#line 3780 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 201: /* cat3_opc: T_OP_SAD_S16  */
#line 927 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAD_S16); }
#line 3786 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 202: /* cat3_opc: T_OP_SAD_S32  */
#line 928 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAD_S32); }
#line 3792 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 204: /* $@24: %empty  */
#line 931 "../src/freedreno/ir3/ir3_parser.y"
                                 { new_instr(OPC_SHLG_B16); }
#line 3798 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 206: /* cat4_opc: T_OP_RCP  */
#line 933 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RCP); }
#line 3804 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 207: /* cat4_opc: T_OP_RSQ  */
#line 934 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RSQ); }
#line 3810 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 208: /* cat4_opc: T_OP_LOG2  */
#line 935 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_LOG2); }
#line 3816 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 209: /* cat4_opc: T_OP_EXP2  */
#line 936 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_EXP2); }
#line 3822 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 210: /* cat4_opc: T_OP_SIN  */
#line 937 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SIN); }
#line 3828 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 211: /* cat4_opc: T_OP_COS  */
#line 938 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_COS); }
#line 3834 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 212: /* cat4_opc: T_OP_SQRT  */
#line 939 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SQRT); }
#line 3840 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 213: /* cat4_opc: T_OP_HRSQ  */
#line 940 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_HRSQ); }
#line 3846 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 214: /* cat4_opc: T_OP_HLOG2  */
#line 941 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_HLOG2); }
#line 3852 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 215: /* cat4_opc: T_OP_HEXP2  */
#line 942 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_HEXP2); }
#line 3858 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 217: /* cat5_opc_dsxypp: T_OP_DSXPP_1  */
#line 946 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DSXPP_1)->cat5.type = TYPE_F32; }
#line 3864 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 218: /* cat5_opc_dsxypp: T_OP_DSYPP_1  */
#line 947 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DSYPP_1)->cat5.type = TYPE_F32; }
#line 3870 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 219: /* cat5_opc: T_OP_ISAM  */
#line 949 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ISAM); }
#line 3876 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 220: /* cat5_opc: T_OP_ISAML  */
#line 950 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ISAML); }
#line 3882 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 221: /* cat5_opc: T_OP_ISAMM  */
#line 951 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ISAMM); }
#line 3888 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 222: /* cat5_opc: T_OP_SAM  */
#line 952 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAM); }
#line 3894 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 223: /* cat5_opc: T_OP_SAMB  */
#line 953 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMB); }
#line 3900 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 224: /* cat5_opc: T_OP_SAML  */
#line 954 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAML); }
#line 3906 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 225: /* cat5_opc: T_OP_SAMGQ  */
#line 955 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGQ); }
#line 3912 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 226: /* cat5_opc: T_OP_GETLOD  */
#line 956 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETLOD); }
#line 3918 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 227: /* cat5_opc: T_OP_CONV  */
#line 957 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CONV); }
#line 3924 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 228: /* cat5_opc: T_OP_CONVM  */
#line 958 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CONVM); }
#line 3930 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 229: /* cat5_opc: T_OP_GETSIZE  */
#line 959 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETSIZE); }
#line 3936 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 230: /* cat5_opc: T_OP_GETBUF  */
#line 960 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETBUF); }
#line 3942 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 231: /* cat5_opc: T_OP_GETPOS  */
#line 961 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETPOS); }
#line 3948 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 232: /* cat5_opc: T_OP_GETINFO  */
#line 962 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETINFO); }
#line 3954 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 233: /* cat5_opc: T_OP_DSX  */
#line 963 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DSX); }
#line 3960 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 234: /* cat5_opc: T_OP_DSY  */
#line 964 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DSY); }
#line 3966 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 235: /* cat5_opc: T_OP_GATHER4R  */
#line 965 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GATHER4R); }
#line 3972 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 236: /* cat5_opc: T_OP_GATHER4G  */
#line 966 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GATHER4G); }
#line 3978 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 237: /* cat5_opc: T_OP_GATHER4B  */
#line 967 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GATHER4B); }
#line 3984 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 238: /* cat5_opc: T_OP_GATHER4A  */
#line 968 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GATHER4A); }
#line 3990 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 239: /* cat5_opc: T_OP_SAMGP0  */
#line 969 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGP0); }
#line 3996 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 240: /* cat5_opc: T_OP_SAMGP1  */
#line 970 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGP1); }
#line 4002 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 241: /* cat5_opc: T_OP_SAMGP2  */
#line 971 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGP2); }
#line 4008 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 242: /* cat5_opc: T_OP_SAMGP3  */
#line 972 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGP3); }
#line 4014 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 243: /* cat5_opc: T_OP_RGETPOS  */
#line 973 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RGETPOS); }
#line 4020 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 244: /* cat5_opc: T_OP_RGETINFO  */
#line 974 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RGETINFO); }
#line 4026 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 245: /* cat5_flag: '.' T_3D  */
#line 976 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_3D; }
#line 4032 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 246: /* cat5_flag: '.' 'a'  */
#line 977 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_A; }
#line 4038 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 247: /* cat5_flag: '.' 'o'  */
#line 978 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_O; }
#line 4044 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 248: /* cat5_flag: '.' 'p'  */
#line 979 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_P; }
#line 4050 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 249: /* cat5_flag: '.' 's'  */
#line 980 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_S; }
#line 4056 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 250: /* cat5_flag: '.' T_S2EN  */
#line 981 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_S2EN; }
#line 4062 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 251: /* cat5_flag: '.' T_NONUNIFORM  */
#line 982 "../src/freedreno/ir3/ir3_parser.y"
                                     { instr->flags |= IR3_INSTR_NONUNIF; }
#line 4068 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 252: /* cat5_flag: '.' T_BASE  */
#line 983 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_B; instr->cat5.tex_base = (yyvsp[0].tok); }
#line 4074 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 255: /* cat5_samp: T_SAMP  */
#line 987 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat5.samp = (yyvsp[0].tok); }
#line 4080 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 256: /* cat5_tex: T_TEX  */
#line 988 "../src/freedreno/ir3/ir3_parser.y"
                                  { if (instr->flags & IR3_INSTR_B) instr->cat5.samp |= ((yyvsp[0].tok) << 4); else instr->cat5.tex = (yyvsp[0].tok); }
#line 4086 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 257: /* cat5_type: '(' type ')'  */
#line 989 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat5.type = (yyvsp[-1].type); }
#line 4092 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 258: /* cat5_a1: src_reg  */
#line 990 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_A1EN; }
#line 4098 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 274: /* cat6_typed: '.' T_UNTYPED  */
#line 1008 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat6.typed = 0; }
#line 4104 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 275: /* cat6_typed: '.' T_TYPED  */
#line 1009 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat6.typed = 1; }
#line 4110 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 276: /* cat6_dim: '.' T_1D  */
#line 1011 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.d = 1; }
#line 4116 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 277: /* cat6_dim: '.' T_2D  */
#line 1012 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.d = 2; }
#line 4122 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 278: /* cat6_dim: '.' T_3D  */
#line 1013 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.d = 3; }
#line 4128 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 279: /* cat6_dim: '.' T_4D  */
#line 1014 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.d = 4; }
#line 4134 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 280: /* cat6_type: '.' type  */
#line 1016 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.type = (yyvsp[0].type); }
#line 4140 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 281: /* cat6_imm_offset: offset  */
#line 1017 "../src/freedreno/ir3/ir3_parser.y"
                             { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); }
#line 4146 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 284: /* cat6_dst_offset: offset  */
#line 1020 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.dst_offset = (yyvsp[0].num); }
#line 4152 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 285: /* cat6_dst_offset: '+' src  */
#line 1021 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->flags |= IR3_INSTR_G; }
#line 4158 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 286: /* cat6_immed: integer  */
#line 1023 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.iim_val = (yyvsp[0].num); }
#line 4164 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 287: /* cat6_stg_ldg_a6xx_offset: '+' '(' src offset ')' '<' '<' integer  */
#line 1026 "../src/freedreno/ir3/ir3_parser.y"
                                                           {
                        assert((yyvsp[0].num) == 2);
                        new_src(0, IR3_REG_IMMED)->uim_val = 0;
                        new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[-4].num);
                    }
#line 4174 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 288: /* cat6_stg_ldg_a6xx_offset: '+' src '<' '<' integer offset '<' '<' integer  */
#line 1031 "../src/freedreno/ir3/ir3_parser.y"
                                                                  {
                        assert((yyvsp[0].num) == 2);
                        new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[-4].num) - 2;
                        new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[-3].num);
                    }
#line 4184 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 289: /* $@25: %empty  */
#line 1037 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDG); }
#line 4190 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 291: /* $@26: %empty  */
#line 1038 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDG_A); }
#line 4196 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 293: /* $@27: %empty  */
#line 1039 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDP); }
#line 4202 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 295: /* $@28: %empty  */
#line 1040 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDL); }
#line 4208 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 297: /* $@29: %empty  */
#line 1041 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDLW); }
#line 4214 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 299: /* $@30: %empty  */
#line 1042 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDLV); }
#line 4220 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 300: /* $@31: %empty  */
#line 1042 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                  {
                       new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[-1].num);
                   }
#line 4228 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 302: /* $@32: %empty  */
#line 1046 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_STG); dummy_dst(); }
#line 4234 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 304: /* $@33: %empty  */
#line 1047 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_STG_A); dummy_dst(); }
#line 4240 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 306: /* $@34: %empty  */
#line 1048 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_STP); dummy_dst(); }
#line 4246 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 308: /* $@35: %empty  */
#line 1049 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_STL); dummy_dst(); }
#line 4252 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 310: /* $@36: %empty  */
#line 1050 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_STLW); dummy_dst(); }
#line 4258 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 312: /* $@37: %empty  */
#line 1052 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_LDIB); }
#line 4264 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 314: /* $@38: %empty  */
#line 1053 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_STIB); dummy_dst(); }
#line 4270 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 316: /* $@39: %empty  */
#line 1055 "../src/freedreno/ir3/ir3_parser.y"
                                 { new_instr(OPC_PREFETCH); new_dst(0,0); /* dummy dst */ }
#line 4276 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 318: /* cat6_atomic_opc: T_OP_ATOMIC_ADD  */
#line 1057 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_ADD); }
#line 4282 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 319: /* cat6_atomic_opc: T_OP_ATOMIC_SUB  */
#line 1058 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_SUB); }
#line 4288 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 320: /* cat6_atomic_opc: T_OP_ATOMIC_XCHG  */
#line 1059 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_XCHG); }
#line 4294 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 321: /* cat6_atomic_opc: T_OP_ATOMIC_INC  */
#line 1060 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_INC); }
#line 4300 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 322: /* cat6_atomic_opc: T_OP_ATOMIC_DEC  */
#line 1061 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_DEC); }
#line 4306 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 323: /* cat6_atomic_opc: T_OP_ATOMIC_CMPXCHG  */
#line 1062 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_CMPXCHG); }
#line 4312 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 324: /* cat6_atomic_opc: T_OP_ATOMIC_MIN  */
#line 1063 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_MIN); }
#line 4318 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 325: /* cat6_atomic_opc: T_OP_ATOMIC_MAX  */
#line 1064 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_MAX); }
#line 4324 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 326: /* cat6_atomic_opc: T_OP_ATOMIC_AND  */
#line 1065 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_AND); }
#line 4330 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 327: /* cat6_atomic_opc: T_OP_ATOMIC_OR  */
#line 1066 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_OR); }
#line 4336 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 328: /* cat6_atomic_opc: T_OP_ATOMIC_XOR  */
#line 1067 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_XOR); }
#line 4342 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 329: /* cat6_atomic_g: cat6_atomic_opc cat6_typed cat6_dim cat6_type '.' cat6_immed '.' 'g' dst_reg ',' 'g' '[' cat6_reg_or_immed ']' ',' src ',' src ',' src  */
#line 1069 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                                                                          {
                       instr->flags |= IR3_INSTR_G;
                   }
#line 4350 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 333: /* cat6_ibo_opc_1src: T_OP_RESINFO  */
#line 1078 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RESINFO); }
#line 4356 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 334: /* cat6_ibo_opc_ldgb: T_OP_LDGB  */
#line 1080 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_LDGB); }
#line 4362 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 335: /* cat6_ibo_opc_stgb: T_OP_STGB  */
#line 1081 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_STGB); }
#line 4368 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 338: /* $@40: %empty  */
#line 1085 "../src/freedreno/ir3/ir3_parser.y"
                                                                                  { dummy_dst(); }
#line 4374 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 340: /* cat6_id_opc: T_OP_GETSPID  */
#line 1088 "../src/freedreno/ir3/ir3_parser.y"
                                { new_instr(OPC_GETSPID); }
#line 4380 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 341: /* cat6_id_opc: T_OP_GETWID  */
#line 1089 "../src/freedreno/ir3/ir3_parser.y"
                                { new_instr(OPC_GETWID); }
#line 4386 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 344: /* cat6_bindless_base: '.' T_BASE  */
#line 1094 "../src/freedreno/ir3/ir3_parser.y"
                              { instr->flags |= IR3_INSTR_B; instr->cat6.base = (yyvsp[0].tok); }
#line 4392 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 347: /* cat6_bindless_mode: T_NONUNIFORM cat6_bindless_base  */
#line 1098 "../src/freedreno/ir3/ir3_parser.y"
                                                   { instr->flags |= IR3_INSTR_NONUNIF; }
#line 4398 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 349: /* cat6_reg_or_immed: integer  */
#line 1101 "../src/freedreno/ir3/ir3_parser.y"
                           { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); }
#line 4404 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 350: /* cat6_bindless_ibo_opc_1src: T_OP_RESINFO_B  */
#line 1103 "../src/freedreno/ir3/ir3_parser.y"
                                                 { new_instr(OPC_RESINFO); }
#line 4410 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 351: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_ADD  */
#line 1105 "../src/freedreno/ir3/ir3_parser.y"
                                                     { new_instr(OPC_ATOMIC_ADD)->flags  |= IR3_INSTR_G; dummy_dst(); }
#line 4416 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 352: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_SUB  */
#line 1106 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_SUB)->flags  |= IR3_INSTR_G; dummy_dst(); }
#line 4422 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 353: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_XCHG  */
#line 1107 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_XCHG)->flags |= IR3_INSTR_G; dummy_dst(); }
#line 4428 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 354: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_INC  */
#line 1108 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_INC)->flags  |= IR3_INSTR_G; dummy_dst(); }
#line 4434 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 355: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_DEC  */
#line 1109 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_DEC)->flags  |= IR3_INSTR_G; dummy_dst(); }
#line 4440 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 356: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_CMPXCHG  */
#line 1110 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_CMPXCHG)->flags |= IR3_INSTR_G; dummy_dst(); }
#line 4446 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 357: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_MIN  */
#line 1111 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_MIN)->flags  |= IR3_INSTR_G; dummy_dst(); }
#line 4452 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 358: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_MAX  */
#line 1112 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_MAX)->flags  |= IR3_INSTR_G; dummy_dst(); }
#line 4458 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 359: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_AND  */
#line 1113 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_AND)->flags  |= IR3_INSTR_G; dummy_dst(); }
#line 4464 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 360: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_OR  */
#line 1114 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_OR)->flags   |= IR3_INSTR_G; dummy_dst(); }
#line 4470 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 361: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_XOR  */
#line 1115 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_XOR)->flags  |= IR3_INSTR_G; dummy_dst(); }
#line 4476 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 362: /* cat6_bindless_ibo_opc_2src: T_OP_STIB_B  */
#line 1116 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_STIB); dummy_dst(); }
#line 4482 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 363: /* cat6_bindless_ibo_opc_2src_dst: T_OP_LDIB_B  */
#line 1118 "../src/freedreno/ir3/ir3_parser.y"
                                                         { new_instr(OPC_LDIB); }
#line 4488 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 365: /* cat6_bindless_ibo: cat6_bindless_ibo_opc_2src cat6_typed cat6_dim cat6_type '.' cat6_immed '.' cat6_bindless_mode src_reg ',' cat6_reg_or_immed ',' cat6_reg_or_immed  */
#line 1121 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                                                                                      { swap(instr->srcs[0], instr->srcs[2]); }
#line 4494 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 366: /* cat6_bindless_ibo: cat6_bindless_ibo_opc_2src_dst cat6_typed cat6_dim cat6_type '.' cat6_immed '.' cat6_bindless_mode dst_reg ',' cat6_reg_or_immed ',' cat6_reg_or_immed  */
#line 1122 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                                                                                          { swap(instr->srcs[0], instr->srcs[1]); }
#line 4500 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 367: /* cat6_bindless_ldc_opc: T_OP_LDC  */
#line 1124 "../src/freedreno/ir3/ir3_parser.y"
                                 { new_instr(OPC_LDC); }
#line 4506 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 368: /* cat6_bindless_ldc: cat6_bindless_ldc_opc '.' T_OFFSET '.' cat6_immed '.' cat6_bindless_mode dst_reg ',' cat6_reg_or_immed ',' cat6_reg_or_immed  */
#line 1126 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                                                                {
                      instr->cat6.d = (yyvsp[-9].tok);
                      instr->cat6.type = TYPE_U32;
                      /* TODO cleanup ir3 src order: */
                      swap(instr->srcs[0], instr->srcs[1]);
                   }
#line 4517 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 369: /* cat6_todo: T_OP_G2L  */
#line 1133 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_G2L); }
#line 4523 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 370: /* cat6_todo: T_OP_L2G  */
#line 1134 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_L2G); }
#line 4529 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 371: /* cat6_todo: T_OP_RESFMT  */
#line 1135 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_RESFMT); }
#line 4535 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 383: /* cat7_scope: '.' 'w'  */
#line 1149 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat7.w = true; }
#line 4541 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 384: /* cat7_scope: '.' 'r'  */
#line 1150 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat7.r = true; }
#line 4547 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 385: /* cat7_scope: '.' 'l'  */
#line 1151 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat7.l = true; }
#line 4553 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 386: /* cat7_scope: '.' 'g'  */
#line 1152 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat7.g = true; }
#line 4559 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 389: /* $@41: %empty  */
#line 1157 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_BAR); }
#line 4565 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 391: /* $@42: %empty  */
#line 1158 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_FENCE); }
#line 4571 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 394: /* src: T_REGISTER  */
#line 1162 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_src((yyvsp[0].num), 0); }
#line 4577 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 395: /* src: T_A0  */
#line 1163 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_src((61 << 3), IR3_REG_HALF); }
#line 4583 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 396: /* src: T_A1  */
#line 1164 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_src((61 << 3) + 1, IR3_REG_HALF); }
#line 4589 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 397: /* src: T_P0  */
#line 1165 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_src((62 << 3) + (yyvsp[0].num), 0); }
#line 4595 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 398: /* dst: T_REGISTER  */
#line 1167 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_dst((yyvsp[0].num), 0); }
#line 4601 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 399: /* dst: T_A0  */
#line 1168 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_dst((61 << 3), IR3_REG_HALF); }
#line 4607 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 400: /* dst: T_A1  */
#line 1169 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_dst((61 << 3) + 1, IR3_REG_HALF); }
#line 4613 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 401: /* dst: T_P0  */
#line 1170 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_dst((62 << 3) + (yyvsp[0].num), 0); }
#line 4619 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 402: /* const: T_CONSTANT  */
#line 1172 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_src((yyvsp[0].num), IR3_REG_CONST); }
#line 4625 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 403: /* dst_reg_flag: T_EVEN  */
#line 1174 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat1.round = ROUND_EVEN; }
#line 4631 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 404: /* dst_reg_flag: T_POS_INFINITY  */
#line 1175 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat1.round = ROUND_POS_INF; }
#line 4637 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 405: /* dst_reg_flag: T_NEG_INFINITY  */
#line 1176 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat1.round = ROUND_NEG_INF; }
#line 4643 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 406: /* dst_reg_flag: T_EI  */
#line 1177 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_EI; }
#line 4649 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 407: /* dst_reg_flag: T_WRMASK  */
#line 1178 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.wrmask = (yyvsp[0].num); }
#line 4655 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 410: /* dst_reg: dst  */
#line 1184 "../src/freedreno/ir3/ir3_parser.y"
                                       { (yyvsp[0].reg)->flags |= IR3_REG_R; }
#line 4661 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 411: /* dst_reg: dst_reg_flags dst  */
#line 1185 "../src/freedreno/ir3/ir3_parser.y"
                                       { (yyvsp[0].reg)->flags |= IR3_REG_R; }
#line 4667 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 412: /* src_reg_flag: T_ABSNEG  */
#line 1187 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_ABS|IR3_REG_NEGATE; }
#line 4673 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 413: /* src_reg_flag: T_NEG  */
#line 1188 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_NEGATE; }
#line 4679 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 414: /* src_reg_flag: T_ABS  */
#line 1189 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_ABS; }
#line 4685 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 415: /* src_reg_flag: T_R  */
#line 1190 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_R; }
#line 4691 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 433: /* offset: %empty  */
#line 1216 "../src/freedreno/ir3/ir3_parser.y"
                   { (yyval.num) = 0; }
#line 4697 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 434: /* offset: '+' integer  */
#line 1217 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = (yyvsp[0].num); }
#line 4703 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 435: /* offset: '-' integer  */
#line 1218 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = -(yyvsp[0].num); }
#line 4709 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 436: /* relative_gpr_src: 'r' '<' T_A0 offset '>'  */
#line 1220 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_src(0, IR3_REG_RELATIV)->array.offset = (yyvsp[-1].num); }
#line 4715 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 437: /* relative_gpr_src: T_HR '<' T_A0 offset '>'  */
#line 1221 "../src/freedreno/ir3/ir3_parser.y"
                                             { new_src(0, IR3_REG_RELATIV | IR3_REG_HALF)->array.offset = (yyvsp[-1].num); }
#line 4721 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 438: /* relative_gpr_dst: 'r' '<' T_A0 offset '>'  */
#line 1223 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_dst(0, IR3_REG_RELATIV)->array.offset = (yyvsp[-1].num); }
#line 4727 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 439: /* relative_gpr_dst: T_HR '<' T_A0 offset '>'  */
#line 1224 "../src/freedreno/ir3/ir3_parser.y"
                                             { new_dst(0, IR3_REG_RELATIV | IR3_REG_HALF)->array.offset = (yyvsp[-1].num); }
#line 4733 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 440: /* relative_const: 'c' '<' T_A0 offset '>'  */
#line 1226 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_src(0, IR3_REG_RELATIV | IR3_REG_CONST)->array.offset = (yyvsp[-1].num); }
#line 4739 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 441: /* relative_const: T_HC '<' T_A0 offset '>'  */
#line 1227 "../src/freedreno/ir3/ir3_parser.y"
                                             { new_src(0, IR3_REG_RELATIV | IR3_REG_CONST | IR3_REG_HALF)->array.offset = (yyvsp[-1].num); }
#line 4745 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 444: /* immediate_cat1: integer  */
#line 1236 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->iim_val = type_size(instr->cat1.src_type) < 32 ? (yyvsp[0].num) & 0xffff : (yyvsp[0].num); }
#line 4751 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 445: /* immediate_cat1: '(' integer ')'  */
#line 1237 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = (yyvsp[-1].num); }
#line 4757 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 446: /* immediate_cat1: '(' float ')'  */
#line 1238 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = (yyvsp[-1].flt); }
#line 4763 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 447: /* immediate_cat1: 'h' '(' integer ')'  */
#line 1239 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED | IR3_REG_HALF)->iim_val = (yyvsp[-1].num) & 0xffff; }
#line 4769 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 448: /* immediate_cat1: 'h' '(' float ')'  */
#line 1240 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED | IR3_REG_HALF)->uim_val = _mesa_float_to_half((yyvsp[-1].flt)); }
#line 4775 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 449: /* immediate_cat1: '(' T_NAN ')'  */
#line 1241 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = NAN; }
#line 4781 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 450: /* immediate_cat1: '(' T_INF ')'  */
#line 1242 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = INFINITY; }
#line 4787 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 451: /* immediate: integer  */
#line 1244 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); }
#line 4793 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 452: /* immediate: '(' integer ')'  */
#line 1245 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = (yyvsp[-1].num); }
#line 4799 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 453: /* immediate: flut_immed  */
#line 1246 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[0].num); }
#line 4805 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 454: /* immediate: 'h' '(' integer ')'  */
#line 1247 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED | IR3_REG_HALF)->iim_val = (yyvsp[-1].num); }
#line 4811 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 455: /* immediate: 'h' flut_immed  */
#line 1248 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED | IR3_REG_HALF)->uim_val = (yyvsp[0].num); }
#line 4817 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 468: /* integer: T_INT  */
#line 1264 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = (yyvsp[0].num); }
#line 4823 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 469: /* integer: '-' T_INT  */
#line 1265 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = -(yyvsp[0].num); }
#line 4829 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 470: /* integer: T_HEX  */
#line 1266 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = (yyvsp[0].unum); }
#line 4835 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 471: /* integer: '-' T_HEX  */
#line 1267 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = -(yyvsp[0].unum); }
#line 4841 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 472: /* float: T_FLOAT  */
#line 1269 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.flt) = (yyvsp[0].flt); }
#line 4847 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 473: /* float: '-' T_FLOAT  */
#line 1270 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.flt) = -(yyvsp[0].flt); }
#line 4853 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 474: /* type: T_TYPE_F16  */
#line 1272 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_F16; }
#line 4859 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 475: /* type: T_TYPE_F32  */
#line 1273 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_F32; }
#line 4865 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 476: /* type: T_TYPE_U16  */
#line 1274 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_U16; }
#line 4871 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 477: /* type: T_TYPE_U32  */
#line 1275 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_U32; }
#line 4877 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 478: /* type: T_TYPE_S16  */
#line 1276 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_S16; }
#line 4883 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 479: /* type: T_TYPE_S32  */
#line 1277 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_S32; }
#line 4889 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 480: /* type: T_TYPE_U8  */
#line 1278 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_U8;  }
#line 4895 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 481: /* type: T_TYPE_S8  */
#line 1279 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_S8;  }
#line 4901 "src/freedreno/ir3/ir3_parser.c"
    break;


#line 4905 "src/freedreno/ir3/ir3_parser.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yytoken};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          goto yyexhaustedlab;
      }
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if 1
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

